#!/usr/bin/perl
#
### CONTROL PANEL SCRIPT FOR ULTIMATE BULLETIN BOARD ##
#
# Ultimate Bulletin Board is copyright Infopop Corporation, 1998-2000.
#
#       ------------ cpanel.cgi -------------
#
#  This file contains some of the control panel functionality for
#  the UBB.  It is called from the controlpanel pages (cp.html).
#
#  Infopop Corporation offers no
#  warranties on this script.  The owner/licensee of the script is
#  solely responsible for any problems caused by installation of
#  the script or use of the script, including messages that may be
#  posted on the BB.
#
#  All copyright notices regarding the Ultimate Bulletin Board
#  must remain intact on the scripts and in the HTML
#  for the scripts.
#
# For more info on the Ultimate BB, 
# see http://www.UltimateBB.com
#
###############################################################
#If you are running UBB on IIS,
#you may need to add the following line
#if so, just remove the "#" sign before the print line below
#print "HTTP/1.0 200 OK\n";

print ("Content-type: text/html\n\n");
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file

require "UltBB.setup";
require "mods.file";
require "Styles.file";
require "ubb_library.pl";
require "ubb_library2.pl";
};

if ($@) {
    print "<HTML><BODY><p>FEHLER: Folgende Datei(en) konnte(n) nicht geladen werden:</p>";
    print "<p>Stellen Sie sicher, da&szlig; Sie die Dateien UltBB.setup, Styles.file, mods.file und forums.cgi im ASCII/Text-Modus in Ihr cgi-Verzeichnis geladen haben. [Achten Sie auf die Einstellungen Ihres FTP-Programms!]</p><p>Achten Sie auf Gro&szlig;- und Kleinschreibung: UltBB.setup nicht ultbb.setup !</p>\n\n";
    print "<p>Hier die Fehlermeldung:</p><p>$@</p>\n\n</BODY></HTML>";
 exit;
}

&ReadParse;

foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);

	if ($Name eq "action") {
			$action = $Value;
	}
	if ($Name eq "Email") {
			$Email = $Value;
			$Email =~tr/A-Z/a-z/;  
		}
	if ($Name eq "UserName") {
			$UserName = $Value;
		}
	if ($Name eq "Password") {
			$Password = $Value;
		}
} #end foreach loop

if ($VariablesPath eq "") {
	$VariablesPath = $CGIPath;
}

if ($action eq "setmods") {
   &SetMods;
}
if ($action eq "UpdateThreads") {
   &UpdateThreads;
}
if ($action eq "prune") {
   &Prune;
}
if ($action eq "digest") {
   &Digest;
}
if ($action eq "index") {
   &Index;
}
if ($action eq "archives") {
   &Archives;
}
if ($action eq "addforums") {
   &AddForums;
}
if ($action eq "banlists") {
   &BanLists;
}
if ($action eq "variables") {
   &Variables;
}

if ($action eq "permissions") {
   &Permissions;
}

if ($action eq "env") {
   &Env;
}
if ($action eq "misc") {
   &Misc;
}
if ($action eq "mail") {
   &Mail;
}
if ($action eq "style") {
   &Styles;
}

if ($action eq "logintoforums") {
   &LogIntoForums;
}

sub Styles {
if ($profilegif eq "") {
	$profilegif = "profile.gif";
}
if ($mailgif eq "") {
	$mailgif = "email.gif";
}
if ($CopyrightTextColor eq "") {
	$CopyrightTextColor = "#C0C0C0";
}
if ($TextSize eq "") {
	$TextSize = "2";
}
if ($TextColor eq "") {
	$TextColor = "#000000";
}
if ($LinkColor eq "") {
	$LinkColor = "#000080";
}
if ($VisitedLinkColor eq "") {
	$VisitedLinkColor = "#808000";
}
if ($ActiveLinkColor eq "") {
	$ActiveLinkColor = "#800000";
}
if ($TableStripTextColor eq "") {
	$TableStripTextColor = "#000080";
}
if ($CategoryStripTextColor eq "") {
	$CategoryStripTextColor = "#000000";
}

if ($BBTitle eq "") {
	$BBTitle = "bbtitle1.jpg";
}
if ($BBTopic eq "") {
	$BBTopic = "topic1.jpg";
}
if ($BBReply eq "") {
	$BBReply = "reply1.jpg";
}
if ($ThreadClosed eq "") {
	$ThreadClosed = "threadclose1.jpg";
}
if ($TableWidth eq "") {
	$TableWidth = "95%";
}
if ($FDTextSize eq "") {
	$FDTextSize = "1";
}
if ($TimeColor eq "") {
	$TimeColor = "#800080";
}
if ($BBTitleFontColor eq "") {
	$BBTitleFontColor = "#800000";
}

$PageTitle = " O P T I S C H E &nbsp;&nbsp;&nbsp;&nbsp; E I N S T E L L U N G E N";
&HEADERHTML1;

print<<StyleHTML;
Hier k&ouml;nnen Sie die Schriftart und/oder -Farbe, Grafiken und Hintergrund-Farben f&uuml;r die Anzeige Ihres UBB einstellen oder &auml;ndern. Hinweis: Diese Daten ver&auml;ndern nur das Aussehen des UBB nicht die Systemadministration. F&uuml;r die Angabe der Farben empfehlen wir die Benutzung hexadezimaler Codes (z.B., #FFFFFF f&uuml;r "white", etc.). Die hier angegebenen Men&uuml;-Punkte sind globale Ver&auml;nderungen an dem Aussehen Ihres UBB. Individuelle optische &Auml;nderungen Ihrer Foren k&ouml;nnen Sie in den Forum-Einstellungen ver&auml;ndern. 
</FONT>
<P>
<FORM ACTION="$CGIURL/cpanel2.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="sendstyle">
<center>
<table border=0 cellpadding=0 cellspacing=0 width="95%"><TR><td bgcolor="#000000">

<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>
<TR bgcolor="#B0BB9D">
<TD colspan=4>
<FONT FACE="Verdana" SIZE="2"><B>Farb-Optionen</B></FONT></TD></TR>
StyleHTML

&ColorRow("Hintergrund", "Format - #FFFFFF", "BGColor", "#C7C6BA");
&ColorRow("Schrift", "", "TextColor", "#D5D2BB");
&ColorRow("Link", "", "LinkColor", "#C7C6BA");
&ColorRow("Aktiver Link", "", "ActiveLinkColor", "#D5D2BB");
&ColorRow("Besuchter Link", "", "VisitedLinkColor", "#C7C6BA");
&ColorRow("Tabellenr&auml;nder", "", "TableBorderColor", "#D5D2BB");
&ColorRow("Tabellenkopf - Schriftfarbe", "", "TableStripTextColor", "#C7C6BA");
&ColorRow("Tabellenkopf - Hintergrund", "", "TableColorStrip", "#D5D2BB");
&ColorRow("Datum und Zeit", "Diese Farbe wird zur Darstellung der Zeitfelder in der Hauptseite sowie der &Uuml;bersicht eines Forums von UBB sowie f&uuml;r \"erstellt von\" -Zeile f&uuml;r jeden Beitrag verwendet.", "TimeColor", "#C7C6BA");
&ColorRow("Erste Zeilenfarbe in Tabellen", "", "AltColumnColor1", "#D5D2BB");
&ColorRow("Zweite Zeilenfarbe in Tabellen", "", "AltColumnColor2", "#C7C6BA");
&ColorRow("Kategorie-Zeile - Hintergrund", "", "CategoryStripColor", "#D5D2BB");
&ColorRow("Kategorie-Zeile - Schriftfarbe", "", "CategoryStripTextColor", "#C7C6BA");
&ColorRow("Copyright - Textfarbe", "", "CopyrightTextColor", "#D5D2BB");
&ColorRow("UBB Titel - Textfarbe", "", "BBTitleFontColor", "#C7C6BA");

print<<Style12;
<tr bgcolor="#B0BB9D">
<td colspan=4><B><FONT FACE="Verdana" SIZE="2">Grafische Optionen</FONT></B></TD>
</TR>
<tr bgcolor="#D5D2BB">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Schriftart (z.B. Verdana)</B></FONT><br><FONT SIZE="1" FACE="Verdana, Arial">Wir empfehlen den Einsatz von mehreren Schriftarten. Als Beispiel: Benutzen Sie Verdana als erste Wahl, Arial als Schriftart f&uuml;r die Benutzer, welche Verdana nicht auf ihrem System installiert haben. Mehrere Schriftarten geben Sie so an: "Verdana, Arial".</FONT><br>
</td>
<td valign=top colspan="3">
<INPUT TYPE="TEXT" NAME="FontFace" VALUE="$FontFace" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Breite der Tabellen</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial">Sie k&ouml;nnen die Tabellenbreite in Pixel (empfohlen: 600 Pixel) oder als Prozent-Angabe (empfohlen: 90%) angeben.</FONT>
</td>
<td valign=top colspan="3">
<INPUT TYPE="TEXT" NAME="TableWidth" VALUE="$TableWidth" SIZE=5 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#d5d2bb">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Schriftgr&ouml;&szlig;e</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial">Wir empfehlen die Gr&ouml;&szlig;e 2 - abh&auml;ngig von der von Ihnen verwendete Schriftart k&ouml;nnen Sie diesen Wert entsprechend anpassen.</FONT>
</td>
<td valign=top  colspan="3">
<INPUT TYPE="TEXT" NAME="TextSize" VALUE="$TextSize" SIZE=1 MAXLENGTH=1>
</td></tr>

<tr bgcolor="#c7c6ba">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Schriftgr&ouml;&szlig;e - Beschreibung der Foren</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial">Die Standardeinstellung f&uuml;r die Beschreibungstexte der Foren ist die gleiche wie die Textgr&ouml;&szlig;e (s.o.). Beispiel: Geben Sie hier die Schriftgr&ouml;&szlig;e 1 ein, die Standardschriftgr&ouml;&szlig;e ist 2 (s.o.) erscheinen die Forum-Titel etwas pr&auml;gnanter als die Beschreibungen.</FONT>
</td>
<td valign=top colspan="3">
<INPUT TYPE="TEXT" NAME="FDTextSize" VALUE="$FDTextSize" SIZE=1 MAXLENGTH=1>
</td></tr>

<tr bgcolor="#d5d2bb">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Hintergrund-Grafik</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial">Nicht empfohlen, jedoch k&ouml;nnen Sie eine Hintergrund-Grafik f&uuml;r die Anzeige Ihrer Seiten definieren. Wenn ja, sollten Sie die entsprechende Grafik-Datei in das NonCGI-Verzeichnis von UBB uploaden und den Namen hier eintragen. Beispiel: hintergrund.gif.</FONT>
</td>
<td valign=top colspan="3">
<INPUT TYPE="TEXT" NAME="PageBackground" VALUE="$PageBackground" SIZE=30 MAXLENGTH=200>
</td></tr>
<tr bgcolor="#B0BB9D">
<td colspan=4><b><FONT FACE="Verdana" SIZE="2"> Grafiken</b></b>
<P><FONT FACE="Verdana" SIZE="2">
Sie k&ouml;nnen aus sechs fertigen Sets w&auml;hlen oder Ihre eigenen verwenden. UBB benutzt haupts&auml;chlich drei Grafiken - die Titel- oder Logo-Grafik, welche auf den meisten Seiten oben erscheint, eine "Neuen Beitrag erstellen"-Grafik, eine "Antwort erstellen"-Grafik, und eine "Beitrag geschlossen"-Grafik. Die hier verf&uuml;gbaren Grafiken wurden von Karen Vail erstellt. 
<P>
Eine &Uuml;bersicht der vorhandenen Grafiken erhalten Sie <A HREF="$NonCGIURL/graphicsets.html">hier</A>.  M&ouml;chten Sie eine der gezeigten Grafiken verwenden, geben Sie den Dateinamen in das entsprechende Feld ein. Um eigene Grafiken zu verwenden, geben Sie den entsprechenden Namen ein. Denken Sie daran, die Dateien in Ihr NonCGI-Verzeichnis per FTP zu legen. 
<P>
Empfohlene Gr&ouml;&szlig;en: Wenn Sie Ihre eigenen Grafiken erstellen m&ouml;chten, empfehlen wir folgende Gr&ouml;&szlig;en (in Pixel):<ul>
<LI> Titel-/Logo-Grafik - 300 x 75 Pixel (B x H) 
<LI> Neuen Beitrag erstellen - Grafik - 80 x 17 Pixel (B x H) 
<LI> Antwort erstellen - Grafik - 75 x 17 Pixel (B x H) 
<LI> Beitrag geschlossen - Grafik - 75 x 17 Pixel (B x H) 
</ul><br>
Nicht vergessen: Senden Sie Ihre erstellten Grafiken per FTP in Ihr NonCGI-Verzeichnis. 
</FONT></TD>
</TR>
<tr bgcolor="#c7c6ba">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Titel-/Logo-Grafik:</B></FONT></td>
<td valign=top colspan="3">
<INPUT TYPE="TEXT" NAME="BBTitle" VALUE="$BBTitle" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#d5d2bb">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Neuen Beitrag erstellen - Grafik:</B></FONT>
</td>
<td valign=top colspan="3">
<INPUT TYPE="TEXT" NAME="BBTopic" VALUE="$BBTopic" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Antwort erstellen - Grafik:</B></FONT>
</td>
<td valign=top colspan="3">
<INPUT TYPE="TEXT" NAME="BBReply" VALUE="$BBReply" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#d5d2bb">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Beitrag geschlossen - Grafik:</B></FONT>
</td>
<td valign=top colspan="3">
<INPUT TYPE="TEXT" NAME="ThreadClosed" VALUE="$ThreadClosed" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Profil - Grafik:</B></FONT>
</td>
<td valign=top colspan="3">
<INPUT TYPE="TEXT" NAME="profilegif" VALUE="$profilegif" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#d5d2bb">
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>eMail - Grafik: </B></FONT>
</td>
<td valign=top colspan="3">
<INPUT TYPE="TEXT" NAME="mailgif" VALUE="$mailgif" SIZE=25 MAXLENGTH=50>
</td></tr>
<TR bgcolor="#B0BB9D"><TD colspan="4">
<CENTER><FONT COLOR="#000000" face="Verdana, Arial" Size="2">Ausschlie&szlig;lich Administratoren k&ouml;nnen diese &Auml;nderungen durchf&uuml;hren.<br>Bitte identifizieren Sie sich:</FONT></CENTER>
</td></tr>
<TR bgcolor="#FFFFF">
<TD>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Ihr Benutzername</B></FONT>
</td>
<td colspan="3"><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td>
<TR bgcolor="#FFFFF">
<td>
<B><FONT SIZE="2" FACE="Verdana, Arial">Ihr Kennwort</FONT></B>
</td>
<td colspan="3">
<INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td></tr></table>
</td></tr></table>
<P>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="&Auml;nderungen speichern">
</FORM>
<P><BR>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#C0C0C0">Powered by: Infopop &copy; 2000<br>Ultimate Bulletin Board $Version<br>Deutsche Version von thinkfactory.</FONT></CENTER>
</BODY>
</HTML>
Style12
}  ## END Styles subroutine

sub UpdateThreads {
$PageTitle = "U P D A T E &nbsp;&nbsp;D E R&nbsp;&nbsp; B E I T R &Auml; G E";
&HEADERHTML1;

print<<Threads;
<FONT SIZE="1" FACE="Verdana, Arial">HINWEIS: Nur Administratoren k&ouml;nnen ein Update der HTML-Dateien durchf&uuml;hren.<P>
Nachdem Sie &Auml;nderungen in der Systemadministration vorgenommen haben, werden diese sofort &uuml;bernommen. Foren, die bereits Beitr&auml;ge enthalten, werden nicht ver&auml;ndert - bleiben also in der alten Fassung. Mit dieser Update-Funktion werden die bereits vorhandenen Seiten ebenfalls aktualisiert. 
</FONT>
<FORM ACTION="$CGIURL/postings.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="doupdate">
<center>
<table border=0 cellpadding=0 cellspacing=0 width="90%"><TR><td bgcolor="#000000">
<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>
<tr bgcolor="#FFFFFF">
<TD>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Ihr Benutzername:</B></FONT>
</td>
<td><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td></tr>
<TR bgcolor="#FFFFFF">
<td>
<B><FONT SIZE="2" FACE="Verdana, Arial">Ihr Kennwort:</FONT></B>
</td>
<td>
<INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td></tr>

<TR bgcolor="#B0BB9D">
<td>
<P><B><FONT SIZE="2" FACE="Verdana, Arial">Welche Foren sollen aktualisiert werden?</FONT></B><BR><FONT SIZE="1" FACE="Verdana, Arial">Bei einem Upgrade von UBB sollten Sie alle Foren aktualisieren. Wenn Sie die Optik eines einzelnen Forums ver&auml;ndert haben, gen&uuml;gt eine Aktualisierung nur dieses Forums.</FONT></P>
</td>
<td valign=top>
<SELECT NAME="UpdateForumChoice">
	<OPTION VALUE="ALL" SELECTED>Alle Foren
Threads

@forumfile = &OpenFile("$VariablesPath/forums.cgi");
foreach $one(@forumfile) {
@thisforum = split(/\|/, $one);
$ForumNumber = $thisforum[8];
$ForumName = $thisforum[1];
print qq(<OPTION VALUE="$ForumNumber">$ForumName);
}

print<<Threads2;
</SELECT>
</td></tr>
<TR bgcolor="#FFFFFF">
<td>
<p><B><FONT SIZE="2" FACE="Verdana, Arial">Update-Zyklus</FONT></B><BR><FONT SIZE="1" FACE="Verdana, Arial">Abh&auml;ngig von der Leistung Ihres Servers sowie der Anzahl der vorhandenen Beitr&auml;ge , k&ouml;nnen Sie bestimmen, ob UBB die Beitr&auml;ge in kleinen oder gro&szlig;en Schritten, welche eine h&ouml;here Server-Belastung darstellen, durchf&uuml;hren soll. Die Standard-Einstellung ist: 150 Beitr&auml;ge gleichzeitig per Forum. Sollte das Update der Beitr&auml;ge nicht ordnungsgem&auml;&szlig; beendet werden, verringern Sie den Zyklus. Bei einwandfreiem Ablauf k&ouml;nnen Sie nat&uuml;rlich testweise den Zyklus erh&ouml;hen!</FONT></P>
</td>
<td valign=top>
<SELECT NAME="Cycle">
	<OPTION>30
	<OPTION>60
	<OPTION>100
	<OPTION SELECTED>150
	<OPTION>200
	<OPTION>230
	<OPTION>300
</SELECT>
</td></tr>
</table>
</td></tr></table>
<p>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Update durchf&uuml;hren!">
</CENTER>

</FORM>
</BODY></HTML>
Threads2

}  ## END UpdateThreads SR ##


sub Archives {
$PageTitle = "A R C H I V E";
&HEADERHTML1;

print<<Threads;
Archive sind <B>nur lesbare</B> Sektionen Ihres UBB, in welchen &auml;ltere Beitr&auml;ge aus Ihren Foren gespeichert werden. Archive werden komplett getrennt von den Foren behandelt. Der Sinn eines Archivs ist das permanente Speichern diverser Beitr&auml;ge, welche Sie f&uuml;r alle Zeiten Ihren Benutzern zur Verf&uuml;gung stellen m&ouml;chten.
<P>
Archive m&uuml;ssen nicht identisch zu den vorhandenen Foren sein, Sie k&ouml;nnen zum Beispiel 9 Foren eingerichtet haben, jedoch nur ein Archiv!
<P>
Themen werden durch Klick auf "Im Archiv ablegen" auf der aktuellen Seite in das Archiv bewegt. <P>
Um Archive zu erstellen, l&ouml;schen oder zu ver&auml;ndern, identifizieren Sie sich bitte.  HINWEIS: Nur Administratoren k&ouml;nnen Archive erstellen oder ver&auml;ndern. Sie k&ouml;nnen bis zu 40 Archive erstellen.<P>
<FORM ACTION="$CGIURL/archive.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="enterarchive">
<center>
Threads

&IDTable;

print<<ArchiveBottom;
<p>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Archive betreten!">
</CENTER>
</FORM>
</BODY></HTML>
ArchiveBottom
}  ## END Archives SR ##

sub Index {
$PageTitle = "U P D A T E &nbsp;&nbsp; O D E R &nbsp;&nbsp; E R S T E L L E N &nbsp;&nbsp; D E S &nbsp;&nbsp; I N D E X";
&HEADERHTML1;

print<<Index;
<CENTER><FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">Nur Administratoren oder Moderatoren k&ouml;nnen den Index erzeugen oder ein Update durchf&uuml;hren.</FONT></CENTER>
<P>
Der Index wird f&uuml;r die Suchfunktion von UBB benutzt. Bei einem Upgrade von einer Version von UBB, welche keine Suchfunktion enth&auml;lt, M&Uuml;SSEN Sie den Index erzeugen, damit die Suchfunktion funktioniert. Klicken Sie einfach unten auf den Button! Sollte die Suchfunktion nicht ordnungsgem&auml;&szlig; funktionieren, k&ouml;nnen Sie jederzeit die Indizierung erneut vornehmen. 
<P>
Sie sollten das Update des Index jedesmal nachdem Sie Nachrichten durch die Systemadministration L&Ouml;SCHEN entfernt haben. Diese Funktion wird von UBB nicht automatisch durchgef&uuml;hrt. 
<P>
<FORM ACTION="$CGIURL/cpanel2.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="doindex">
<center>
Index

&IDTable;

print<<Index2;
<p>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Indizierung durchf&uuml;hren!">
</CENTER>
</FORM>
</BODY></HTML>
Index2

}  ## END INDEX SR ##

sub LogIntoForums {
&AssembleCats;
$PageTitle = "F O R U M &nbsp;&nbsp;-&nbsp;&nbsp; E I N S T E L L U N G E N";
&HEADERHTML1;

print<<ForumLoginHTML;
<center>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">Forum-Einstellungen k&ouml;nnen nur durch Administratoren durchgef&uuml;hrt werden.</FONT>
<P>
<FORM ACTION="$CGIURL/cpanel3.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
ForumLoginHTML

&IDTable;

print<<ENDIT;
<P></font>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="forums">
<INPUT TYPE="HIDDEN" NAME="StartPoint" VALUE="0">
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Identifikation senden">
</FORM>
<BR><BR><BR>
<FONT SIZE="1" FACE="Verdana, Arial">Powered by: Infopop &copy; 2000<br>Ultimate Bulletin Board $Version<br>Deutsche Version von thinkfactory.
</FONT>
</CENTER></BODY></HTML>
ENDIT
}  # end logintoforums sr


sub BanLists {
$PageTitle = "B E N U T Z E R &nbsp;&nbsp; O D E R &nbsp;&nbsp; I P &nbsp;&nbsp; S P E R R E N";
&HEADERHTML1;

print<<ForumLoginHTML;
<center>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">Nur Administratoren k&ouml;nnen Benutzer per eMail- oder IP-Adresse sperren.</FONT>
<P>
</center>
<FONT SIZE="1" FACE="Verdana, Arial">
HINWEIS: Wenn Sie von der Version 5.38 ein Upgrade durchf&uuml;hren, m&uuml;ssen Sie die generellen Einstellungen von UBB zur&uuml;cksetzen, um bereits vorhandenen Sperrungen beizubehalten.</font><center>
<P>
<FORM ACTION="$CGIURL/cpanel3.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
ForumLoginHTML

&IDTable;

print<<ENDIT;
<P></font>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="viewbanlist">
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Identifikation senden!">
</FORM>
<BR><BR><BR>
<FONT SIZE="1" FACE="Verdana, Arial">Powered by: Infopop &copy; 2000<br>Ultimate Bulletin Board $Version<br>Deutsche Version von thinkfactory.
</FONT>
</CENTER></BODY></HTML>
ENDIT
}  # end banlists sr

sub Env {
if ( (-e "$CGIPath/edit.cgi") && (-e "$MembersPath/memberslist.cgi")  && (-d "$NonCGIPath/Forum3") ) {
	&get_cookie;
	if($cookie{'UserNameCP'}) {
		&VerifyAdminCP($cookie{'UserNameCP'},$cookie{'PasswordCP'}); # make sure they logged in
		unless ($Proceed eq "true") {	
		  &StandardHTMLCP("Sie konnten nicht als Administrator best&auml;tigt werden - bitte benutzen Sie die Funktion \"Generelle Einstellungen\" um die Authentifizierung durchzuf&uuml;hren'.");
		  exit;	
		}
	} else {&StandardHTML("Die Pfadangaben f&uuml;r Ihr Ultimate Bulletin Board sind korrekt eingestellt.<p>Aus Sicherheitsgr&uuml;nden sind die generellen Einstellungen nur f&uuml;r Administratoren verf&uuml;gbar.<br>Bitte benutzen Sie die Funktion \"Generelle Einstellungen\" um die Authentifizierung durchzuf&uuml;hren.");
	  exit;
	}
}	
	
	
print<<TOP;
<HTML><BODY BGCOLOR="#FFFFFF">
<BR><BR>
<CENTER><FONT SIZE="5" FACE="Courier New" ><B>Ihre Umgebungsvariablen</b></FONT></CENTER>
<P>
<font face="Verdana, Arial" size="2">
Benutzen Sie diese Funktion, um Ihre absoluten Pfade korrekt zu erkennen und zu &uuml;bernehmen sowie weitere Informationen &uuml;ber den Webserver zu erfahren.<P>
<FONT face="Verdana, Arial" size="2" COLOR="#800000"><B>Perl Info:</b></FONT><BR>
Installierte Perl-Version: <b>Perl Version $]</b>
<P>
<FONT face-"Verdana, Arial" size="2" COLOR="#800000"><B>Ihre Umgebungsvariablen:</b></FONT>
<BR>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#008080">Hinweis: "DOCUMENT_ROOT" zeigt den absoluten Pfad zu Ihrem Root-Verzeichnis auf Ihrem Webserver. "SCRIPT_FILENAME" zeigt den absoluten Pfad zu Ihrem CGI-Verzeichnis. Wenn SCRIPT_FILENAME "/www/wasauchimmer/woauchimmer/cgi-bin/cpanel.cgi" zeigt, sollte Ihre Angabe f&uuml;r den absoluten Pfad zu Ihrem CGI-Verzeichnis "/www/wasauchimmer/woauchimmer/cgi-bin" lauten.</FONT><P>
TOP
for $key (keys(%ENV)) {
printf("%-10.20s: <b>$ENV{$key}</B><BR>", $key);
}

print<<BOTTOM;
</FONT></BODY></HTML>
BOTTOM
}  # END ENV SR

sub AddForums {

# check to see how many forums are currently listed
@forums = &OpenForumsFile;
$ForumTotal = @forums;
$ForumCounter = $ForumTotal + 1;

my @CATEGORIES = &OpenFile("$NonCGIPath/categories.file");
my $CategoryDropDown = qq(<SELECT NAME="Category">);
$CategoryDropDown .= qq(<OPTION Value="" SELECTED>Bitte w&auml;hlen:);
$CategoryDropDown .= qq(<OPTION Value="">Keine Kategorie);
$Count = 0;
foreach $cat(@CATEGORIES) {
$Count++;
($Junk, $CatName, $CatNumber) = split(/\|\|\|/, $cat);
chomp($CatNumber);
$CategoryDropDown .= qq(<OPTION value="$CatNumber">$CatName);
}

if ($Count == 0) {
$CategoryDropDown .= qq(<OPTION value="">Keine Kategorien vorhanden!);
}
$CategoryDropDown .= "</SELECT>";

$PageTitle = "N E U E S &nbsp;&nbsp;&nbsp;&nbsp; F O R U M &nbsp;&nbsp;&nbsp;&nbsp; H I N Z U F &Uuml; G E N";
&HEADERHTML1;

print<<ForumHTML;
<B>
Mit diesem Formular k&ouml;nnen Sie ein neues Forum erstellen. Es existieren derzeit $ForumTotal Foren.  
<P>
</B>
<P>
<FORM ACTION="$CGIURL/cpanel3.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
<FONT FACE="VERDANA, ARIAL">Hinweis: Nur Administratoren k&ouml;nnen neue Foren erstellen.</FONT><BR>
<table border=0><TR><TD>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Ihr Benutzername:</B></FONT>
</td><td><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td></tr>
<TR><td><B><FONT SIZE="2" FACE="Verdana, Arial">Ihr Kennwort:</FONT></B>
</td><td><INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td></tr></table>
<hr>
<table border=0 width=95%><TR bgcolor="#FFFFFF"><TD>
<B><FONT SIZE="3" FACE="Verdana, Arial" COLOR="#800000">Neues Forum erstellen</FONT></B></td>
<TD align=center><FONT SIZE="2" FACE="Verdana, Arial">[<A HREF="$NonCGIURL/forumterms.html" target=_new>Erkl&auml;rung der Forum-Variablen</A>]</FONT></td></TR></table>
<P>
<TABLE BORDER=0 cellspacing=0 cellpadding=0 width=95%><TR><td bgcolor="#000000">
<table border=0 width=100%>
<tr bgcolor="#D3CE87">
<td colspan=4 valign=top>
<FONT SIZE="2" FACE="Verdana, Arial">
<B>Forum $ForumCounter</B></td></tr>
<TR bgcolor="#c7c6ba">
<TD>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Name:</B></FONT></td>
<td colspan=3><INPUT TYPE="TEXT" NAME="Namer" VALUE="Name des Forums:" SIZE=30 MAXLENGTH=100></td></tr>
<tr bgcolor="#d5d2bb"><td><FONT SIZE="1" FACE="Verdana, Arial"><B>
Kategorie:</B></FONT></td>
<td colspan=3>$CategoryDropDown</td></tr>

<TR bgcolor="#C7C6BA"><TD><FONT SIZE="1" FACE="Verdana, Arial"><B>Status:</B></FONT></td>
<td colspan=3><FONT SIZE="1" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="Status" VALUE="On" CHECKED> An &nbsp;&nbsp;&nbsp;&nbsp;
<INPUT TYPE="RADIO" NAME="Status" VALUE="Off"> Aus</B></FONT></td></tr>

<TR bgcolor="#D5D2BB"><TD><FONT SIZE="1" FACE="Verdana, Arial"><B>HTML-Code erlaubt?</B></FONT></td><TD colspan=3><FONT SIZE="1" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="HTML" VALUE="is"> Ja &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="RADIO" NAME="HTML" VALUE="is not" CHECKED> Nein</B></FONT></td></tr>

<TR bgcolor="#C7C6BA"><TD><FONT SIZE="1" FACE="Verdana, Arial"><B>UBB-Code erlaubt?</B></FONT></td><TD colspan=3><FONT SIZE="1" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="UBB" VALUE="is" CHECKED> Ja &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="RADIO" NAME="UBB" VALUE="is not"> Nein</B></FONT></td></tr>

<TR bgcolor="#D5D2BB"><TD><FONT SIZE="1" FACE="Verdana, Arial"><B>UBB-Code inklusive Grafiken?</B></FONT></td><TD colspan=3><FONT SIZE="1" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="UBBImages" VALUE="ON" CHECKED> Ja &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="RADIO" NAME="UBBImages" VALUE="OFF"> Nein</B></FONT></td></tr>

<TR bgcolor="#C7C6BA" ><TD><FONT SIZE="1" FACE="Verdana, Arial"><B>Information an den Moderator? <BR></B><FONT SIZE="1" FACE="Verdana, Arial">Ist diese Funktion aktiviert, erh&auml;lt der Moderator bei jedem neuen Beitrag in seinem Forum eine eMail. (Nicht empfohlen!)</FONT></FONT></td><TD colspan=3 valign=top><FONT SIZE="1" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="ModNotify" VALUE="yes"> Ja &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="RADIO" NAME="ModNotify" VALUE="no" CHECKED> Nein</B></FONT></td></tr>

<TR bgcolor="#D5D2BB"><TD valign=top><FONT SIZE="1" FACE="Verdana, Arial" color="#800000"><B>Zugriffsrechte</B></font><BR><FONT SIZE="1" FACE="Verdana, Arial">Sie k&ouml;nnen dieses Forum als privates Forum definieren, was bedeutet, da&szlig; lediglich Administratoren, Moderatoren oder Benutzer, denen Sie den Zugriff gew&auml;hren in diesem Forum lesen oder schreiben k&ouml;nnen. Wenn Sie ein Kennwort f&uuml;r dieses Forum vergeben, k&ouml;nnen Benutzer, denen das Kennwort bekannt ist, ebenfalls darauf zugreifen. 
<P>
Wenn Sie dieses Forum nicht als v&ouml;llig privates Forum definieren m&ouml;chten, k&ouml;nnen Sie den Zugriff auf verschiedene Varianten limitieren. 
<P>
<BR><FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">Forum-Kennwort:</font> <INPUT TYPE="TEXT" NAME="forumpw" VALUE="" SIZE=12 MAXLENGTH=12>
</FONT></td><TD colspan=3 valign=top><FONT SIZE="1" FACE="Verdana, Arial"><B>
<CENTER>Privates Forum - Lesen/Schreiben</CENTER><P>
<INPUT TYPE="CHECKBOX" NAME="Private" VALUE="private">
Das Forum auf Administratoren, Moderatoren und andere autorisierte<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">*</FONT> Benutzer einschr&auml;nken.
<P>
Wenn Sie das Forum limitiert haben, k&ouml;nnen Sie durch die Auswahl der maximalen Sicherheit alle Anzeigen in diesem Forum dynamisch einstellen, so da&szlig; der Benutzer sich vor jeder Anzeige mit Benutzernamen und dem entsprechenden Kennwort legitimieren mu&szlig;. Bei minimaler Sicherheit werden die Beitr&auml;ge in einer HTML-Datei gespeichert, so da&szlig; der Aufruf bei geringerer Sicherheit direkt vom Server schneller erfolgen kann. 
<blockquote>
<INPUT TYPE="RADIO" NAME="PrivateMax" VALUE="yes" CHECKED>Maximale Sicherheit<BR>
<INPUT TYPE="RADIO" NAME="PrivateMax" VALUE="no">Minimale Sicherheit
</blockquote>
<HR>
<BR>
<CENTER>Limitation des Erstellen von Beitr&auml;gen</CENTER>
<P>
Ist Ihr Forum nichtg als privates Forum definiert, k&ouml;nnen Sie hier einstellen, wer auf Beitr&auml;ge antworten oder neue Beitr&auml;ge erstellen darf. 
<P>
Wer darf Beitr&auml;ge erstellen? 
<BR>
<SELECT NAME="TopicRestrict">
<option value="restrict">Nur Administratoren, Moderatoren und autorisierte Benutzer
<option value="allreg" SELECTED>Jeder registrierte(r) Benutzer
<option value="all">Alle Benutzer - auch unregistrierte
</SELECT>
<P>

Wer darf Antworten erstellen?
<BR>
<SELECT NAME="ReplyRestrict">
<option value="restrict">Nur Administratoren, Moderatoren und autorisierte Benutzer
<option value="allreg" SELECTED>Jeder registrierter Benutzer
<option value="all">Alle Benutzer - auch unregistrierte
<option value="none">Es d&uuml;rfen keine Antworten erstellt werden.
</SELECT>

</B></FONT>
<P>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">* Ein autorisierter Benutzer ist ein Benutzer, welcher kein Administrator oder Moderator ist, sondern durch einen Administrator in seinem Benutzer-Eintrag einen Zugang zu diesem Forum freigeschalten oder das Forum-Kennwort &uuml;bermittelt bekommen hat. </FONT>
</td></tr>

<TR bgcolor="#c7c6ba" ><TD valign=top><FONT SIZE="2" FACE="Verdana, Arial"><B>Beschreibung des Forums:</B></FONT><BR><FONT SIZE="1" FACE="Verdana, Arial">Diese Beschreibung wird auf der &Uuml;bersicht aller Foren unter dem Namen des Forums angezeigt.  Achten Sie darauf, da&szlig; Sie in den generellen Einstellungen die Anzeige der Forum-Beschreibungen aktiviert haben.</font></td><td  colspan=3 valign=top><TEXTAREA NAME="Description" ROWS=3 COLS=30 wrap="VIRTUAL"></TEXTAREA></td></tr>


<TR bgcolor="#d5d2bb"><td valign=top><p><FONT SIZE="2" FACE="Verdana, Arial"><b>Individuelle Kopfzeile (Header)</b></font><br>
<FONT SIZE="1" FACE="Verdana, Arial">Sie k&ouml;nnen diesem Forum einen individuellen Kopf zur Darstellung zuweisen, die ggf. vorhandenen Daten des Kopfs in den Darstellungs-Einstellungen werden dann &uuml;berschrieben.</p></font>
</td><td colspan=3><TEXTAREA NAME="ForumHeader" ROWS=5 COLS=30 wrap="VIRTUAL"></TEXTAREA></td></tr>

<TR bgcolor="#d5d2bb"><td valign=top><p><FONT SIZE="2" FACE="Verdana, Arial"><b>Individuelle Fu&szlig;zeile (Footer)</b></font><br>
<FONT SIZE="1" FACE="Verdana, Arial">Sie k&ouml;nnen diesem Forum einen individuellen Fu&szlig; zur Darstellung zuweisen, die ggf. vorhandenen Daten des Footers in den Darstellungs-Einstellungen werden dann &uuml;berschrieben.</p></font>
</td><td colspan=3><TEXTAREA NAME="ForumFooter" ROWS=5 COLS=30 wrap="VIRTUAL"></TEXTAREA></td></tr>

ForumHTML


print<<MoreForumGuts;
<TR bgcolor="#D3CE87">
<td colspan=4 valign=top>
<FONT SIZE="2" FACE="Verdana, Arial">
<B>Darstellung des Forums</B><P>HINWEIS: Die Standardwerte zur Darstellung von UBB werden in dem Men&uuml; Darstellung definiert. Hier k&ouml;nnen Sie jedem Forum ein individuelles Aussehen zuweisen. M&ouml;chten Sie eigene Grafiken verwenden, m&uuml;ssen diese per FTP in Ihr NonCGI-Verzeichnis &uuml;bertragen werden.</font></td></tr>
MoreForumGuts

&ColorRow("Hintergrundfarbe", "Format - #FFFFFF", "BGColor", "#D5D2BB","colspan=2");
&ColorRow("Schriftfarbe", "", "TextColor", "#C7C6BA","colspan=2");
&ColorRow("Farbe eines Links", "", "LinkColor", "#D5D2BB","colspan=2");
&ColorRow("Farbe eines aktiven Links", "", "ActiveLinkColor", "#C7C6BA","colspan=2");
&ColorRow("Farbe eines besuchten Links", "", "VisitedLinkColor", "#D5D2BB","colspan=2");
&ColorRow("Farbe des Tabellenrands", "", "TableBorderColor", "#C7C6BA","colspan=2");
&ColorRow("Tabellenkopf - Schriftfarbe", "", "TableStripTextColor", "#D5D2BB","colspan=2");
&ColorRow("Tabellenkopf - Hintergrundfarbe", "", "TableColorStrip", "#C7C6BA","colspan=2");
&ColorRow("Farbe der Zeitangaben", "Diese Farbe wird zur Darstellung der Zeitfelder in der Hauptseite sowie der &Uuml;bersicht eines Forums von UBB sowie der \"erstellt von\"-Zeile f&uuml;r jeden Beitrag verwendet.", "TimeColor", "#D5D2BB","colspan=2");
&ColorRow("Erste Zeilenfarbe in Tabellen", "", "AltColumnColor1", "#C7C6BA","colspan=2");
&ColorRow("Zweite Zeilenfarbe in Tablellen", "", "AltColumnColor2", "#D5D2BB","colspan=2");
&ColorRow("Kategorie-Zeile - Hintergrundfarbe", "", "CategoryStripColor", "#C7C6BA","colspan=2");
&ColorRow("Kategorie-Zeile - Textfarbe", "", "CategoryStripTextColor", "#D5D2BB","colspan=2");
&ColorRow("Copyright Text-Farbe", "", "CopyrightTextColor", "#C7C6BA","colspan=2");

print<<ForumGuts;
<tr bgcolor="#d5d2bb">
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Schriftart (z.B. Verdana)</B></FONT><br><FONT SIZE="1" FACE="Verdana, Arial">Wir empfehlen den Einsatz von mehreren Schriftarten. Als Beispiel: Benutzen Sie Verdana als erste Wahl, Arial als Schriftart f&uuml;r die Benutzer, welche Verdana nicht auf ihrem System installiert haben. Mehrere Schriftarten geben Sie so an: \"Verdana, Arial\"</FONT><br>
</td>
<td colspan=2 valign=top>
<INPUT TYPE="TEXT" NAME="FontFace" VALUE="$FontFace" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Tabellenbreite</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial">Sie k&ouml;nnen die Tabellenbreite in Pixel (empfohlen: 600 Pixel) oder als Prozent-Angabe (empfohlen: 90%) angeben.</FONT>
</td>
<td colspan=2 valign=top>
<INPUT TYPE="TEXT" NAME="TableWidth" VALUE="$TableWidth" SIZE=5 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#d5d2bb">
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Schriftgr&ouml;&szlig;e</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial">Wir empfehlen die Gr&ouml;&szlig;e 2 - abh&auml;ngig von der von Ihnen verwendete Schriftart k&ouml;nnen Sie diesen Wert entsprechend anpassen.</FONT>
</td>
<td colspan=2 valign=top>
<INPUT TYPE="TEXT" NAME="TextSize" VALUE="$TextSize" SIZE=1 MAXLENGTH=1>
</td></tr>

<tr bgcolor="#c7c6ba">
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>Hintergrund-Grafik</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial">Nicht empfohlen, jedoch k&ouml;nnen Sie eine Hintergrund-Grafik f&uuml;r die Anzeige Ihrer Seiten definieren. Wenn ja, sollten Sie die entsprechende Grafik-Datei in das NonCGI-Verzeichnis von UBB uploaden und den Namen hier eintragen. Beispiel: hintergrund.gif.</FONT></p>
</td>
<td colspan=2 valign=top>
<INPUT TYPE="TEXT" NAME="PageBackground" VALUE="$PageBackground" SIZE=30 MAXLENGTH=200>
</td></tr>

<tr bgcolor="#d5d2bb">
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Titel-/Logo-Grafik:</B></FONT></td>
<td colspan=2 valign=top>
<INPUT TYPE="TEXT" NAME="BBTitle" VALUE="$BBTitle" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Beitrag erstellen - Grafik:</B></FONT>
</td>
<td colspan=2 valign=top>
<INPUT TYPE="TEXT" NAME="BBTopic" VALUE="$BBTopic" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#d5d2bb">
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Antwort erstellen - Grafik:</B></FONT>
</td>
<td colspan=2 valign=top>
<INPUT TYPE="TEXT" NAME="BBReply" VALUE="$BBReply" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Beitrag geschlossen - Grafik:</B></FONT>
</td>
<td colspan=2 valign=top>
<INPUT TYPE="TEXT" NAME="ThreadClosed" VALUE="$ThreadClosed" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#d5d2bb">
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Profil - Grafik:</B></FONT>
</td>
<td valign=top colspan=2>
<INPUT TYPE="TEXT" NAME="profilegif" VALUE="$profilegif" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#c7c6ba">
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial"><B>eMail - Grafik:</B></FONT>
</td>
<td valign=top colspan=2>
<INPUT TYPE="TEXT" NAME="mailgif" VALUE="$mailgif" SIZE=25 MAXLENGTH=50>
</td></tr>
</table>
</td></tr></table>
<P><BR>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="addnewforum">
<INPUT TYPE="HIDDEN" NAME="Number" VALUE="$ForumCounter">
<CENTER><INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Neues Forum hinzuf&uuml;gen">
</FORM>
<P>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#C0C0C0">Powered by: Infopop &copy; 2000<br>Ultimate Bulletin Board $Version<br>Deutsche Version von thinkfactory.</FONT>
</CENTER></font>
</BODY>
</HTML>
ForumGuts
}  ## END AddForums

sub Permissions {
$PageTitle = "B E N U T Z E R - &nbsp;&nbsp;&nbsp;&nbsp; I N F O &nbsp;&nbsp;&nbsp; & &nbsp;&nbsp;&nbsp;&nbsp; Z U G R I F F S R E C H T E";
&HEADERHTML1;

print<<permissHTML;
Administratoren k&ouml;nnen die Zugriffsrechte f&uuml;r jeden registrierten Benutzer von UBB ver&auml;ndern. 
<P>
Klicken Sie <A HREF="$CGIURL/Ultimate.cgi?action=register">hier</A>, um einen neuen Benutzer zu registrieren.


<FORM action=$CGIURL/cpanel4.cgi method=post name=THEFORM2 onsubmit="return Check(this)">
  <CENTER>
    <TABLE border=1 width="85%">
      <TBODY> 
      <TR bgColor=#8ea3b7> 
        <TD colSpan=2><FONT face="Verdana, Arial" size=2><B>Registrations-Antr&auml;ge verwalten</B></FONT> 
        </TD>
      </TR>
      <TR bgColor=#8ea3b7> 
        <TD><FONT face="Verdana, Arial" size=1><B>Benutzername des Administrators: </B></FONT><BR>
          <INPUT maxLength=25 name=UserName size=25>
        </TD>
        <TD><FONT face="Verdana, Arial" size=1><B>Kennwort des Administrators:</B></FONT><BR>
          <INPUT maxLength=15 name=Password size=15 
      type=password>
        </TD>
      </TR>
      <TR bgColor=#c6cfa0> 
        <TD vAlign=top width=200 colspan="2">&nbsp;</TD>
      </TR>
      <TR bgColor=#c6cfa0> 
        <TD width=200 align="right"><font face="Verdana, Arial" size=1><b>Anzeigen von</font></b></font> 
        </TD>
        <TD><font size=1><font face="Verdana, Arial size="1"> 
          <input type="radio" name="matchon" value="">
          allen neuen Registrationen 
          <input type="radio" name="matchon" value="^&" checked>
          alle Benutzer ohne Schreibrechte 
          <input type="radio" name="matchon" value="COPPA">
          COPPA (13 Jahre)</font></TD>
      </TR>
      <TR bgColor=#c6cfa0> 
        <TD width=200 align="right"><b><font size="1" face="Verdana, Arial">Durchsuchen 
          der letzten &nbsp;</font></b></TD>
        <TD>
          <SELECT name=searchback>
            <option value="10" selected>10</option>
            <option value="25">25</option>
            <option value="50">50</option>
            <option value="100">100</option>
            <option value="250">250</option>
            <option value="500">500</option>
            <option value="all">all</option>
          </SELECT>
           <b><font size="1"face="Verdana, Arial">&nbsp;Registrationen </font></b></TD>
      </TR>
      <TR bgColor=#c6cfa0> 
        <TD vAlign=top width=200>&nbsp;</TD>
        <TD>&nbsp;</TD>
      </TR>
      <TR bgColor=#c6cfa0> 
        <TD>&nbsp; </TD>
        <TD>&nbsp; </TD>
      </TR>
      </TBODY> 
    </TABLE>
    <BR>
    <input type="hidden" name="action" value="modregs">
    <INPUT name=Submit type=submit value="Daten anfordern!"> 
<INPUT name=Reset type=reset value="Felder l&ouml;schen"> </center></FORM><CENTER>
  <P><BR>
  </P>
</CENTER></FONT>

<P>


<FORM ACTION="$CGIURL/cpanel4.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="getmatches">
<center>
<table border=1 width="85%">
<tr bgcolor="#8EA3B7"><TD colspan=2><FONT SIZE="2" FACE="Verdana, Arial">
<B>Suche nach registrierten Benutzern:</B></font>
</td></tr>
<tr bgcolor="#8EA3B7"><td><FONT SIZE="1" FACE="Verdana, Arial"><B>Benutzername des Administrators: </B></FONT><BR><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td>
<td>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Kennwort des Administrators:</B></FONT><BR><INPUT TYPE="PASSWORD" NAME="Password" SIZE=15 MAXLENGTH=15></td>
</tr>

<TR bgcolor="#C6CFA0" >
<TD colspan=2>&nbsp;</td></tr>

<TR  bgcolor="#C6CFA0">
<TD WIDTH=200 VALIGN=TOP><FONT SIZE="1" FACE="Verdana, Arial"><B>Benutzername</B></FONT></td>
<td><INPUT TYPE="TEXT" NAME="NN" VALUE="" SIZE=25 MAXLENGTH=25></td></tr>
<TR bgColor=#c6cfa0>
        <TD vAlign=top width=200><b><font size="1" FACE="Verdana, Arial">Status</font></b></TD>
        <TD> 
          <select name="Status">
            <option selected value=''>Bitte w&auml;hlen</option>
            <option value="Admin">Administratoren</option>
            <option value="Mod">Moderatoren</option>
            <option value="COPPA">COPPA (Alter unter 13 Jahren)</option>
          </select>
        </TD>
      </TR>
permissHTML



# get Private Forum select List
@forumlist = &OpenForumsFile;

#fixed by Graeme
foreach(@forumlist){
	if (/\|private\|/){
	@privateforum = split(/\|/,"$_");
        $privateforumnumber = $privateforum[8];
	$privateforumnumber *= 1;
	$selectlist .= "<option value=\"$privateforumnumber\">$privateforum[1]</option>\n";
	}	
}

if ($selectlist) {
print "<tr bgColor=#c6cfa0><td><b><font size=\"1\" FACE=\"Verdana, Arial\">Zugriff auf private Foren</font></b></td><td>\n";
print "<select name=\"PrivateForum\">\n<OPTION VALUE='' SELECTED>Bitte w&auml;hlen\n$selectlist\n </select></td></tr>";
}

print<<permissHTML;
<TR  bgcolor="#C6CFA0">
<TD WIDTH=200 VALIGN=TOP><FONT SIZE="1" FACE="Verdana, Arial"><B>eMail-Adresse</B></FONT></td>
<td><INPUT TYPE="TEXT" NAME="Email" VALUE="" SIZE=30 MAXLENGTH=70></td></tr>
<TR  bgcolor="#C6CFA0">
<TD WIDTH=200 VALIGN=TOP><FONT SIZE="1" FACE="Verdana, Arial"><B>Erstellte Beitr&auml;ge</B></FONT></td>
<td><SELECT NAME="Math">
	<OPTION VALUE="GT"> \>=
	<OPTION VALUE="LT"> \<=
	<OPTION VALUE="EQ"> ==

</SELECT>
<INPUT TYPE="TEXT" NAME="Posts" VALUE="" SIZE=3 MAXLENGTH=5></td></tr>
<TR bgcolor="#C6CFA0">
<TD>
<INPUT TYPE="CHECKBOX" NAME="ViewEntire" VALUE="Yes"><FONT SIZE="1" FACE="Verdana, Arial"><B> &nbsp;Anzeige aller registrierten Benutzer.</b></font>
</td><td>&nbsp;</td></tr>

</table>
<BR>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Daten anfordern!">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Felder l&ouml;schen">
</form>
<p>
<FONT SIZE="2" FACE="Verdana, Arial">
<B><A HREF="$NonCGIURL/controlpanel.html">Administration</A> | <A HREF="$CGIURL/Ultimate.cgi?action=intro">Ihr UBB</A></B>
</FONT>
<br><br><FONT SIZE="1" FACE="Verdana" COLOR="#000000">Powered by: Infopop &copy; 2000<br>Ultimate Bulletin Board $Version<br>Deutsche Version von thinkfactory.
</FONT></CENTER>
</FONT>
</BODY>
</HTML>
permissHTML
} ## END Permissions ##

sub Variables {

$PageTitle = "G E N E R E L L E &nbsp;&nbsp;&nbsp;&nbsp; E I N S T E L L U N G E N";


if ( (-e "$CGIPath/edit.cgi") && (-e "$MembersPath/memberslist.cgi")  && (-d "$NonCGIPath/Forum3") ) {

&HEADERHTML1;
print<<VARHTML;
<p><FONT SIZE="2" FACE="Verdana, Arial">Die Pfadangaben f&uuml;r Ihr UBB sind bereits konfiguriert - bitte identifizieren Sie sich:</B></FONT>
<p>
<center>
<FORM ACTION="cpanel2.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
VARHTML

&IDTable;

print<<BOTTOM;
<p>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="sendvarID">
<CENTER><INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Identifikation senden">
</FORM></center>
<p><FONT SIZE="2" FACE="Verdana, Arial" COLOR="#800000"><B>HINWEIS:</B> Wenn Sie ein Update von UBB durchf&uuml;hren, m&uuml;ssen Sie Ihr System wie folgt zur&uuml;ckstellen: GENERELLE EINSTELLUNGEN, DARSTELLUNGSOPTIONEN, FORUM-EINSTELLUNGEN, UPDATE DER BEITR&Auml;GE, INDEX. Sie m&uuml;ssen keine Angaben in den hier genannten Einstellungen ver&auml;ndern, best&auml;tigen Sie diese lediglich, um das Update zu vervollst&auml;ndigen.</FONT>
</p>
<BR><BR><BR>
<center><FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000000">Powered by: Infopop &copy; 2000<br>Ultimate Bulletin Board $Version<br>Deutsche Version von thinkfactory.
</FONT></CENTER></BODY></HTML>
BOTTOM


}

else { # UBB is not set up yet
print<<VARHTML;

<HTML><HEAD><TITLE>Konfiguration notwendig!</TITLE></HEAD>
<BODY bgcolor="#FFFFFF" text="#000000" >

<p>&nbsp;</p>
<p align=center><FONT SIZE="2" FACE="Verdana, Arial"><b>Vor Benutzung Ihres UBB m&uuml;ssen die absoluten Pfadangaben gepr&uuml;ft und gespeichert werden.</b></FONT>
<P>

<p align=center><FONT SIZE="2" FACE="Verdana, Arial"><B>Bitte klicken Sie <A HREF="cpanel2.cgi?action=DoGenVars">hier</a>.</b>
</p>
<BR><BR><BR>
<center><FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000000">Ultimate Bulletin Board $Version<br>Powered by Infopop &copy; 2000.<br>Deutsche Version von thinkfactory.
</FONT></CENTER></BODY></HTML>
VARHTML

} # end else
}# end SR


sub SetMods {
$PageTitle = "M O D E R A T O R E N";
&HEADERHTML1;

print<<ModTOP;
<CENTER><FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">HINWEIS: Nur Administratoren k&ouml;nnen Moderatoren definieren.</FONT></CENTER>
<P>
<FONT SIZE="2" FACE="Verdana, Arial">
Sie k&ouml;nnen bis zu vier Moderatoren pro Forum definieren. Um einen Moderator zu entfernen, l&ouml;schen Sie einfach das entsprechende Feld.</FONT>
<FORM ACTION="$CGIURL/cpanel2.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="mods">
<center>
<table border=0 cellpadding=0 cellspacing=0 width="90%">
<TR><td bgcolor="#000000">
<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>
<tr bgcolor="#8C9A7A">

<TD>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Ihr Benutzername:</B></FONT><BR><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td>
<td>
<B><FONT SIZE="1" FACE="Verdana, Arial">Ihr Kennwort:</FONT></B><BR><INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td>
</tr>

<TR bgcolor="#B0BB9D">
<TD>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080"><B>Forum</B></FONT>
</td>
<td>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080"><B>Moderator(en):</B></FONT>
</td></tr>
ModTOP

#get current moderator info
$ForumTotal = &GetTotalForums;

for ($x = 1; $x <= $ForumTotal; $x++) {

@thisforum = &GetForumRecord($x);

$ForumName = "$thisforum[1]";
my $Moderator = ("Forum" . "$x" . "Moderator");
$Moderator = $$Moderator;
my ($Mod1, $Mod2, $Mod3, $Mod4) = split(/\|\|\^\|\|/, $Moderator);

print<<MIDMOD;
<TR bgcolor="#C7C6BA">
<TD>
<FONT SIZE="1" FACE="Verdana, Arial"><B>$ForumName</B></FONT>
</td>
<td>
<INPUT TYPE="HIDDEN" NAME="OldMod$x" VALUE="$Moderator">
<INPUT TYPE="TEXT" NAME="1NewMod$x" VALUE="$Mod1" SIZE=18 MAXLENGTH=25>
<INPUT TYPE="TEXT" NAME="2NewMod$x" VALUE="$Mod2" SIZE=18 MAXLENGTH=25>
<INPUT TYPE="TEXT" NAME="3NewMod$x" VALUE="$Mod3" SIZE=18 MAXLENGTH=25>
<INPUT TYPE="TEXT" NAME="4NewMod$x" VALUE="$Mod4" SIZE=18 MAXLENGTH=25>
</td></tr>
MIDMOD

} ##END FOREACH $line


print<<TRUEBOTTOM;
<tr bgcolor="#B0BB9D">
<TD colspan=3 align=center>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="&Auml;nderungen speichern">
</td></tr>
</table>
</td></tr></table>
<P>
</FORM>
<BR>
<FONT SIZE="1" FACE="Verdana, Arial">Powered by: Infopop &copy; 2000<br>Ultimate Bulletin Board $Version<br>Deutsche Version von thinkfactory.</FONT></font></CENTER>
</BODY></HTML>
TRUEBOTTOM

}  ## END SET MODS SR ##


sub Prune {
$PageTitle = "B E I T R &Auml; G E &nbsp;&nbsp; E D I T I E R E N &nbsp;&nbsp; O D E R &nbsp;&nbsp; L &Ouml; S C H E N";
&HEADERHTML1;

print<<PruneHTML;
<B><FONT SIZE="2" FACE="Verdana, Arial" COLOR="#800000">HINWEIS: Nur Moderatoren oder Administratoren k&ouml;nnen Beitr&auml;ge editieren oder l&ouml;schen. Moderatoren k&ouml;nnen Beitr&auml;ge in ihren Foren ver&auml;ndern. Bitte identifizieren Sie sich:</FONT></B>
<FORM ACTION="$CGIURL/edit.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
<center>
<table border=0 cellpadding=0 cellspacing=0 width=90%>
<TR><TD bgcolor="#000000">

<table border=0 width=100%>
<tr bgcolor="#8EA3B7"><TD colspan=3><FONT SIZE="2" FACE="Verdana, Arial">
<B>Identifikation des Administrators/Moderators:</B></font>
</td></tr>
<tr bgcolor="#8EA3B7">
<td width=25>&nbsp;</td>
<td><FONT SIZE="1" FACE="Verdana, Arial"><B>Benutzername: </B></FONT><BR><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td>
<td>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Kennwort:</B></FONT><BR><INPUT TYPE="PASSWORD" NAME="Password" SIZE=15 MAXLENGTH=15></td>
</tr>
<TR bgcolor="#C6CFA0">
<TD width=25>
<INPUT TYPE="RADIO" NAME="EditFunction" VALUE="Prune" CHECKED></td>
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000080"><B>L&ouml;schen nach Datum</FONT><FONT SIZE="1" FACE="Verdana, Arial"> - mit dieser Option k&ouml;nnen Sie alle Beitr&auml;ge in einem von Ihnen definierten Zeitrahmen l&ouml;schen.</B></FONT>
</b></font>
</td></tr>
<TR bgcolor="#C6CFA0">
<TD width=25 valign=top>
<INPUT TYPE="RADIO" NAME="EditFunction" VALUE="PruneUser"></td>
<td colspan=2>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000080"><B>L&ouml;schen nach Benutzer</FONT><FONT SIZE="1" FACE="Verdana, Arial"> - mit dieser Option k&ouml;nnen Sie alle Beitr&auml;ge eines Benutzers l&ouml;schen. 
<P>
Wenn Sie Nachrichten eines <font color="#800000">registrierten</font> Benutzers l&ouml;schen m&ouml;chten, geben Sie den kompletten oder Teil des Benutzernamens ein, Sie erhalten dann eine Auswahlliste. Wenn Sie Beitr&auml;ge eines <font color="#800000">unregistrierten</font> Benutzers l&ouml;schen m&ouml;chten, m&uuml;ssen Sie den kompletten Benutzernamen eingeben. 
<P>
Benutzername: &nbsp;&nbsp;&nbsp; <INPUT TYPE="TEXT" NAME="DeleteName" SIZE=20 MAXLENGTH=25>
<BR>
Ist dieser Benutzer registriert? <INPUT TYPE="RADIO" NAME="DeleteRegName" VALUE="yes"> 
registriert <INPUT TYPE="RADIO" NAME="DeleteRegName" VALUE="no"> nicht registriert

</B></FONT>
</b></font>
</td></tr>
<TR bgcolor="#C6CFA0">
<td width=25>
<INPUT TYPE="RADIO" NAME="EditFunction" VALUE="Edit">
</td>
<TD colspan=2><FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000080"><B>Beitr&auml;ge editieren/l&ouml;schen</FONT><FONT SIZE="1" FACE="Verdana, Arial"> - editieren oder l&ouml;schen Sie einen bestimmten Beitrag. Wenn Sie Editieren, erscheint in dem Beitrag eine Notiz, da&szlig; dieser durch einen Moderator oder Administrator ver&auml;ndert wurde.</B></FONT>
</td></tr>
</table>
</td></tr></table>
<p>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Weiter!">
</form>
</center>
</BODY>
PruneHTML
}  ## END Prune SR

sub HEADERHTML1 {
print<<HEADER;
<HTML>
<HEAD>
	<TITLE>$BBName</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
function SetCursor() {
var testUserNameCP = getCookie("UserNameCP");

if (testUserNameCP != null) {  
	document.THEFORM.UserName.value = getCookie("UserNameCP");
	document.THEFORM.Password.value = getCookie("PasswordCP");
	  if(document.THEFORM2){
	    document.THEFORM2.UserName.value = getCookie("UserNameCP");
	    document.THEFORM2.Password.value = getCookie("PasswordCP");
	  }
	}  else {
	document.THEFORM.UserName.focus();
}
}

function Check(form)  {
if ((form.Password.value == "") || (form.UserName.value == ""))  {
	alert ("Sie m&uuml;ssen Ihren Benutzernamen und Ihr Kennwort eingeben!");
	return false
	}  else  {
	return true
	}
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length; 
            return unescape(dc.substring(begin, end));  }
}
return null;
}
// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</HEAD>
<BODY bgcolor="#FFFFFF" link="#000080" vlink="#808000" onLoad="SetCursor()">
<BR><center>
<FONT SIZE="2" FACE="Verdana, Arial">$PageTitle</FONT>
</center><P><FONT SIZE="1" FACE="Verdana, Arial">
HEADER
} #end HEADERHTML sr

sub CheckStatus {

		if ($Status =~ m/Administrator/) {
			$AdminStatus = "true";
			} else {
			$AdminStatus = "false";
		}
		

		if ($Status =~ m/Moderator/) {
			$ModStatus = "true";
		} else {
			$ModStatus = "false";
		}
		if ($Permission =~ m/Write/) {
			$AdminWrite = "true";
		} else {
			$AdminWrite = "false";
		}

} #end CheckStatus


sub Mail {
$PageTitle = "E M A I L &nbsp;&nbsp; A N &nbsp;&nbsp; A L L E &nbsp;&nbsp; B E N U T Z E R";
&HEADERHTML1;

print<<Index;
<FONT SIZE="2" FACE="Verdana, Arial"><b>HINWEIS:</b> Nur Administratoren k&ouml;nnen eine eMail an alle Benutzer erstellen. Beachten Sie, da&szlig; diese eMail nicht an Benutzer gesandt wird, die in ihrem Profil den Versand von eMails durch Moderatoren oder Administratoren deaktiviert haben. 
<P>
Diese eMail wird an jeden Benutzer einzeln versandt, der Benutzer erh&auml;lt keine Mitgliederliste in seiner eMail. 
<P>
Sie k&ouml;nnen die eMail-Adressen Ihrer Benutzer auch mit Ihrer eigenen eMail-Software verwenden, dazu steht Ihnen weiter unten eine Export-Funktion zur Verf&uuml;gung. </FONT>
<P>
<FORM ACTION="$CGIURL/ubbmail.cgi" METHOD="POST" NAME="THEFORM">
<INPUT TYPE="HIDDEN" NAME="start" VALUE="0">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="mailusers">
<table border=0>
<TR>
<TD>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Ihr Benutzername:</B></FONT>
</td>
<td><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td>
<TR>
<td>
<B><FONT SIZE="2" FACE="Verdana, Arial">Ihr Kennwort:</FONT></B>
</td>
<td>
<INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td></tr>
<TR>
<td valign=top>
<B><FONT SIZE="2" FACE="Verdana, Arial">Betreffzeile Ihrer eMail:</FONT></B>
</td>
<td><INPUT TYPE="TEXT" NAME="Subject" SIZE=30 MAXLENGTH=90>
</td></tr>
<TR>
<td valign=top>
<B><FONT SIZE="2" FACE="Verdana, Arial">Ihre Nachricht:</FONT></B>
</td>
<td><TEXTAREA NAME="Message" ROWS=10 COLS=25>
</TEXTAREA>
</td></tr>

</table>
<HR>
<FONT SIZE="1" FACE="Verdana, Arial"><INPUT TYPE="CHECKBOX" NAME="createlist" value="yes">&nbsp;&nbsp;
<B>eMail-Liste erstellen: Um eine eMail nicht zu versenden, sondern eine Liste zum Import in Ihre eMail-Software erstellen, klicken Sie hier. Lassen Sie die Betreffzeile und das Nachrichtenfeld leer.</B>
<CENTER><INPUT TYPE="RADIO" NAME="delimit" VALUE="comma">
Getrennt durch Kommata  &nbsp;&nbsp;<INPUT TYPE="RADIO" NAME="delimit" VALUE="line" CHECKED>je eMail-Adresse eine Zeile</CENTER>
</FONT>
<HR>
<center>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="eMail senden / Liste erstellen">
</CENTER>

</FORM>
</BODY></HTML>
Index

}  ## END MAIL SR ##

sub Digest {
$PageTitle = "A B O &nbsp;&nbsp;&nbsp;&nbsp; C E N T E R";
&HEADERHTML1;

print<<Index;
<P>
<FONT SIZE="2" FACE="Verdana, Arial">HINWEIS: Nur Administratoren oder Moderatoren k&ouml;nnen das Abo-Center benutzen. 
<P>
Abos sind gesammelte Beitr&auml;ge &uuml;ber einen bestimmten Zeitraum aus einem Forum. Diese Abos werden per eMail an die Abonnenten versandt. Der Versand erfolgt nicht automatisch, Sie m&uuml;ssen hier die Funktion "Abo versenden" nutzen. 
</FONT>
<P>
<A NAME="currentdigests">Hier die Liste der existierenden Abos:</A>
<P>
<table border=0 width=100%>
<TR bgcolor="#B0BB9D">
<TD><FONT SIZE="1" FACE="Verdana, Arial">Name des Abos</FONT></td>
<TD><FONT SIZE="1" FACE="Verdana, Arial">Forum</FONT></td>
<TD><FONT SIZE="1" FACE="Verdana, Arial">Letzter Versand</FONT></td></tr>
Index

#retrieve current digests...
if (-e "$NonCGIPath/digests/digestsummary.cgi") {
open (DIGESTS, "$NonCGIPath/digests/digestsummary.cgi");
@digestsummary = <DIGESTS>;
close(DIGESTS);

foreach $uno(@digestsummary) {
@thisone = split(/\|/, $uno);
@thisfor = &GetForumRecord($thisone[0]);
my $ForumName = $thisfor[1];
print qq(<tr bgcolor="#C7C6BA"><td><FONT SIZE="1" FACE="Verdana, Arial">$ForumName</font></td><td><FONT SIZE="1" FACE="Verdana, Arial">$thisone[0]</font></td><td><FONT SIZE="1" FACE="Verdana, Arial">$thisone[1]</font></td></tr>);
}

}  else {
	print qq(<tr bgcolor="#C7C6BA"><td align=center colspan=3><FONT SIZE="1" FACE="Verdana, Arial"><B>Es sind keine Abos erstellt worden.</B></font></td></tr>);
}

print<<Index2;
</table>
<P>
<FORM ACTION="$CGIURL/ubbmail.cgi" METHOD="POST" NAME="THEFORM">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="digeststart">
<center>
<table border=0 width=95% cellpadding=0 cellspacing=0><TR><TD bgcolor="#000000">

<table border=0 width=100%>
<TR bgcolor="#B0BB9D">
<TD>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Ihr Benutzername:</B></FONT>
</td>
<td><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td>
<TR bgcolor="#B0BB9D">
<td>
<B><FONT SIZE="2" FACE="Verdana, Arial">Ihr Kennwort:</FONT></B>
</td>
<td>
<INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td></tr>
<TR bgcolor="#C7C6BA">
<td>
<B><FONT SIZE="2" FACE="Verdana, Arial">Was m&ouml;chten Sie durchf&uuml;hren?</FONT></B>
</td>
<td>
<SELECT NAME="DigestOption">
	<OPTION value="1">Neues Abo erstellen
	<OPTION value="2">Vorhandenes Abo l&ouml;schen
	<OPTION value="3">Abonnenten hinzuf&uuml;gen oder l&ouml;schen
	<OPTION value="4">Abo versenden
</SELECT>
</td></tr>

</table>

</td></tr></table>
<P>

<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Weiter!">
</form>
<P>
<FONT SIZE="1" FACE="Verdana, Arial">Powered by: Infopop &copy 2000.<br>Deutsche Version von thinkfactory.</FONT>
</CENTER>

</BODY></HTML>
Index2

}  ## END DIGEST SR ##


sub QueryForID {
print<<ForumLoginHTML;
<HTML>
<HEAD>
	<TITLE>$BBName</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
function SetCursor() {
var testUserNameCP = getCookie("UserNameCP");

if (testUserNameCP != null) {  
	document.THEFORM.UserName.value = getCookie("UserNameCP");
document.THEFORM.Password.value = getCookie("PasswordCP");
	}  else {
	document.THEFORM.UserName.focus();
}
}

function Check(form)  {
if ((form.Password.value == "") || (form.UserName.value == ""))  {
	alert ("Sie m&uuml;ssen Ihren Benutzernamen und Ihr Kennwort eingeben!");
	return false
	}  else  {
	return true
	}
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length; 
            return unescape(dc.substring(begin, end));  }
}
return null;
}
// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</HEAD>
<BODY bgcolor="#FFFFFF" link="#000080" vlink="#808000" onLoad="SetCursor()">
<BR><center>
<FONT SIZE="2" FACE="Verdana, Arial">$PageTitle</FONT>
</center><P><FONT SIZE="1" FACE="Verdana, Arial">
<center>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">Um Forum-Einstellungen zu ver&auml;ndern m&uuml;ssen Sie Administrator sein.</FONT>
<P><FONT SIZE="2" FACE="Verdana, Arial" COLOR="#800000">
$PageIntro</font>
<P>
<FORM ACTION="$CGIURL/cpanel.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
ForumLoginHTML

&IDTable;

print<<ENDIT;
<P></font>
$HiddenFields
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Identifikation senden">
</FORM>
<BR><BR><BR>
<FONT SIZE="1" FACE="Verdana, Arial">Powered by: Infopop &copy 2000.<br>Deutsche Version von thinkfactory.
</FONT>
</CENTER></BODY></HTML>
ENDIT
}


sub Misc {
$PageTitle = "S Y S T E M &nbsp;&nbsp;-&nbsp;&nbsp; O P T I O N E N<BR>D E B U G G I N G &nbsp;&nbsp;-&nbsp;&nbsp; O P T I O N E N";
&HEADERHTML1;

print<<ModTOP;
<CENTER><FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">Hinweis: Diese Funktionen sind ausschlie&szlig;lich durch Administratoren durchf&uuml;hrbar, und sollten nur bei vorhandenen Problemen durchgef&uuml;hrt werden.<BR>  </FONT></CENTER>
<P>
<FORM ACTION="$CGIURL/cpanel4.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="misc">
<center>
<table border=0 cellpadding=0 cellspacing=0 width="90%">
<TR><td bgcolor="#000000">
<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>
<tr bgcolor="#8C9A7A">

<TD>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Ihr Benutzername</B></FONT><BR><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td>
<td>
<B><FONT SIZE="1" FACE="Verdana, Arial">Ihr Kennwort</FONT></B><BR><INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td>
</tr>

<TR bgcolor="#B0BB9D">
<TD colspan=2 align=center>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">
<SELECT NAME="Choice">
<OPTION value="0">Bitte w&auml;hlen Sie:
<OPTION value="0">-----------------------------------
	<OPTION value="1">Unbenutzte HTML-Dateien entfernen
	<OPTION value="2">Mitglieder-Liste regenerieren
</SELECT>
</FONT>
</td></tr>
ModTOP

print<<HTML;
<tr bgcolor="#B0BB9D">
<TD colspan=3 align=center>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Auswahl starten">
</td></tr>
</table>
</td></tr></table>
<P>
</FORM>
<BR>
 <font face="Verdana, Arial" size="2">F O R U M D A T E N &nbsp; &nbsp; &nbsp; R E G E N E R I E R E N </font>

<p>
<center>
  <font color="#800000" face="Verdana, Arial" size="1">Benutzen Sie diese Option, wenn Sie der berzeugung sind, da Daten in einem Forum falsch oder unvollstndig sind. Diese Funktion erstellt interne Daten (wie z.B. die Zhlung der Themen und Beitrge) eines Forums neu.<br>
  </font> 
</center>
<p> 
<form action=$CGIURL/cpanel3.cgi method=post name=THEFORM2 onSubmit="return Check(this)">
  <font face="Verdana, Arial" size="1"> 
  <input name=type type=hidden value=single>
   <input name=action type=hidden value=ContinueLastTimes>
  </font> 
  <center>
    <table border=0 cellpadding=0 cellspacing=0 width="90%">
      <tbody> 
      <tr> 
        <td bgcolor=#000000> 
          <table border=0 cellpadding=4 cellspacing=1 width="100%">
            <tbody> 
            <tr bgcolor=#8c9a7a> 
              <td><font face="Verdana, Arial" size=1><b>Ihr Benutzername</b></font><br>
                <input maxlength=25 name=UserName size=25>
              </td>
              <td><b><font face="Verdana, Arial" size=1>Ihr Kennwort</font></b><br>
                <input maxlength=13 name=Password size=13 type=password>
              </td>
            </tr>
            <tr bgcolor=#b0bb9d> 
              <td align=middle colspan=2><font color="#000080" face="Verdana, Arial" size="1"> 
                <select name=ArrayLine>
                  <option selected value=0>Whlen Sie ein Forum: 

HTML

@forumfile = &OpenFile("$VariablesPath/forums.cgi");
foreach $one(@forumfile) {
@thisforum = split(/\|/, $one);
$ForumNumber = ($thisforum[8] - 1);
$ForumName = $thisforum[1];
print qq(<OPTION VALUE="$ForumNumber">$ForumName\n);
}


print <<HTML2;
                </select>
                </font></td>
            </tr>
            <tr bgcolor=#b0bb9d> 
              <td align=middle colspan=3> 
                <input name=Submit2 type=submit value="Daten regenerieren">
              </td>
            </tr>
            </tbody> 
          </table>
        </td>
      </tr>
      </tbody> 
    </table>
    <p> 
  </center>
</form>

<FONT SIZE="1" FACE="Verdana, Arial">Powered by: Infopop &copy; 2000<br>Ultimate Bulletin Board $Version</FONT></font></CENTER>
</BODY></HTML>
HTML2

}  ## END MISC SR ##


exit(0); # comply with SafePerl
