#!/usr/bin/perl

#
# Ultimate Bulletin Board is copyright Infopop Corporation, 1998-2000.
#
#       ------------ archive.cgi -------------
#

print ("Content-type: text/html\n\n");
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file
require "mods.file";
require "UltBB.setup";
require "Date.pl";
require "ubb_library.pl";
require "ubb_library2.pl";
require "Styles.file";
};

if ($@) {
    print "Fehler beim Aufruf der Datei(en): $@\n";
    print "Stellen Sie sicher, da&szlig; diese Datei(en) vorhanden ist/sind, die Zugriffsrechte und Systempfade korrekt eingestellt sind.";
 exit;
}
&ReadParse;

foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
		if ($Name eq "forum") {
			$Forum = $Value;
			$Forum =~ s/\/\\//g;
			$ForumCoded = &HTMLIFY($Forum);
			$ForumCoded =~ tr/ /+/;
			$Forum = &UNHTMLIFY($Forum);
	}
	if ($Name eq "Password") {
		$Password = $Value;
	}
		if ($Name eq "TopicSubject") {
			$TopicSubject = $Value;
			$TopicSubject =~ s/<.+?>//g;
			$TopicSubject = &UNHTMLIFY($TopicSubject);
	}
	if ($Name eq "UserName") {
		$UserName = $Value;
		$UserNameFile = $UserName;
		$UserNameFile =~ s/ /_/g; #remove spaces
	}
	if ($Name eq "number") {
		$number = $Value;
		unless($number =~ /^\w{1,2}:\d{6}$/i) {
			$number =~ s/\D//g;			
		}
	}
	if ($Name eq "topic") {
			$topic = $Value;
	}

}  # end FOREACH $row

if ($VariablesPath eq "") {
	$VariablesPath = $CGIPath;
}

# if necessary set Random Number- for use in Banner Ads, etc.
if ( ($Header ne "") || ($Footer ne "") ) {

$RandomNumber = &MakeRandomNumber;
$RandomNumber2 = $RandomNumber + 100074;

 if ($Header ne "") {
   $Header =~ s/UBBrandomX/$RandomNumber/isg;
   $Header =~ s/UBBrandomY/$RandomNumber2/isg;
 }
 if ($Footer ne "") {
   $Footer =~ s/UBBrandomX/$RandomNumber/isg;
   $Footer =~ s/UBBrandomY/$RandomNumber2/isg;
 }

} # end if header or footer



#adjust bgcolor variables
if ($BGColor ne ""){
$BGColor = qq(bgcolor="$BGColor");
}
if ($AltColumnColor1 ne ""){
$AltColumnColor1 = qq(bgcolor="$AltColumnColor1");
}
if ($AltColumnColor2 ne ""){
$AltColumnColor2 = qq(bgcolor="$AltColumnColor2");
}
if ($CategoryStripColor ne ""){
$CategoryStripColor = qq(bgcolor="$CategoryStripColor");
}
if ($TableColorStrip ne ""){
$TableColorStrip = qq(bgcolor="$TableColorStrip");
}
if ($PageBackground ne ""){
$PageBackground = qq(background="$NonCGIURL/$PageBackground");
}

if ($TableBorderColor ne ""){
$TableWidth2 = "100%";
$BorderTop = qq(<table border=0 cellpadding=0 cellspacing=0 width="$TableWidth"><TR><td bgcolor="$TableBorderColor">);
$BorderBottom = qq(</td></tr></table> );
}  else {
$TableWidth2 = $TableWidth;
$BorderTop = "";
$BorderBottom = "";
}

if (($in{'action'} eq "transfer") || ($in{'action'} eq "submittransfer")) {
if ($BBStatus eq "OFF") {
&StandardHTML($BBClosedMessage);
exit;
}
}

if ($in{'action'} eq "transfer") {
   &Transfer;
}
if ($in{'action'} eq "submittransfer") {
   &SubmitTransfer;
}
if ($in{'action'} eq "enterarchive") {
   &EnterArchive;
}
if ($in{'action'} eq "archivecenter") {
   &ArchiveCenter;
}
if ($in{'action'} eq "ContinueArchiveUpdate") {
  &ConvertArch2HTML("$in{'ArchiveRow'}", "$in{'TotalArchives'}", "$in{'StartWith'}");
  exit;
}
if ($in{'action'} eq "UpdateArchiveThreads") {
  &UpdateArchThreads("$in{'ArchiveRow'}", "$in{'TotalArchives'}", "$in{'StartWith'}");
  exit;
}
if ($in{'action'} eq "ContinueArchiveIndex") {
	&ReArchiveIndex("$in{'ArchiveRow'}", "$in{'TotalArchives'}", "$in{'StartWith'}");
exit;
}

sub ConvertArch2HTML {
my($ArchRow) = shift;
my($ArchTotal) = shift;
my($StartWith) = shift;

$ArchRow = $ArchRow + 0;
$ArchTotal = $ArchTotal + 0;
$StartWith = $StartWith + 0;

#is this the last archive?
if ($ArchRow == $ArchTotal) {
	$LastArchive = "true";
}  else {
	$LastArchive = "false";
}

my @archives = &OpenFile("$NonCGIPath/Archives/archives.pl");
my $uno = "";
my $Count = 0;

foreach $uno(@archives) {
$Count++;
	if ($Count == $ArchRow) {
		($ThisNumber, $ThisName, $ThisDesc) = split(/\|\#\|/, $uno);
	}
}

#retrieve all topics 
opendir (GETTHREADS, "$NonCGIPath/Archives/Archive-$ThisNumber");
	@threads1 = readdir (GETTHREADS);
closedir (GETTHREADS);

$ArchiveNumber = $ThisNumber;

@threads2 = grep(/\.cgi/, @threads1);
@threads = sort(@threads2);

$TotalThreads = @threads; #total topics in archive
$LastArrayNum = $TotalThreads - 1;

#limit processing to Cycle rate
$Cycle = $in{'Cycle'} + 0;
$ThisCycle = $Cycle - 1;
$ArrayStart = $StartWith - 1;
$End = $StartWith + $ThisCycle;
$ArrayEnd = $End - 1;

if ($LastArrayNum <= $ArrayEnd) {
	$ArrayEnd = $LastArrayNum;
	$FinishedArchive = "true";
}  else {
	$FinishedArchive = "false";
}

@truncated = @threads[$ArrayStart... $ArrayEnd];
$StartPoint = $StartWith;
$LastOne = $ArrayEnd + 1;
$NextStart = $ArrayEnd + 1;

for $eachthread(@truncated) {
	&CreateArchiveHTML("$ThisNumber", "$eachthread", "0", "1");
} #end for threads loop

if ($FinishedArchive eq "true") {
	if ($LastArchive eq "true") {
		&EndUpdate("B E I T R &Auml; G E &nbsp;&nbsp;&nbsp;&nbsp; A K T U A L I S I E R T", "Vielen Dank f&uuml;r Ihre Geduld.  Alle Beitr&auml;ge wurden erfolgreich aktualisiert.");
	} else {
		$ArchRow++;
		&ContinueArchUpdate("$ArchRow", "1", "$ArchTotal", "$Cycle");
	}
} else {
		&ContinueArchUpdate("$ArchRow", "$NextStart", "$ArchTotal", "$Cycle");
}

}

sub ContinueArchUpdate {
my $ArchRow = shift;
my $NextStart = shift;
my $TotalArchie = shift;
my $CycleRate = shift;

$ActionWording = qq(Es wird ein Update aller vorhandenen Beitr&auml;ge durchgef&uuml;hrt.<P>Archiv <FONT FACE="Verdana" SIZE="2" COLOR="Navy">$ThisNumber</FONT> wird derzeit bearbeitet.  Bitte warten Sie!</B><P>Die Beitr&auml;ge <FONT FACE="Verdana" SIZE="2" COLOR="Navy">$StartPoint</font> bis <FONT FACE="Verdana" SIZE="2" COLOR="Navy"> $LastOne </font> im Archiv <FONT FACE="Verdana" SIZE="2" COLOR="Navy">$ThisNumber</font> wurden bearbeitet.
</FONT>);
$ForwardURL = "$CGIURL/archive.cgi?action=ContinueArchiveUpdate&ArchiveRow=$ArchRow&TotalArchives=$TotalArchie&StartWith=$NextStart&Cycle=$Cycle";
&ContinueThis($ForwardURL, $ActionWording);

}


sub ArchiveCenter {

&VerifyAdmin($in{'UserNameCheck'}, $in{'PasswordCheck'});

if ($Proceed eq "true") {

if ($in{'ArchiveOption'} eq "Create") {

#validate fields
if ( ($in{'ArchiveName'} eq "") || ($in{'ArchiveName'} !~ /[a-zA-Z0-9]/) || ($in{'UserNameCheck'} eq "") || ($in{'PasswordCheck'} eq "") ) {
&StandardHTML("Ihre Anfrage konnte nicht bearbeitet werden, Sie haben nicht alle Pflichtfelder ausgef&uuml;llt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}
if ( ($in{'ArchiveName'} =~ /\|\#\|/) || ($in{'ArchiveDesc'} =~ /\|\#\|/) )  {
&StandardHTML("Ihre Anfrage konnte nicht bearbeitet werden, bitte benutzen Sie keine Sonderzeichen wie |#| in der Bezeichnung Ihres Archivs - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}

#add archive directory if necessary
unless (-e "$NonCGIPath/Archives") {
mkdir ("$NonCGIPath/Archives", 0777);
chmod(0777, "$NonCGIPath/Archives");
}

#add new archive
#get current archive facts
if (-e "$NonCGIPath/Archives/archives.pl") {
@archiveinfo = &OpenFile("$NonCGIPath/Archives/archives.pl");
@sortarch = sort(@archiveinfo);
@reversearch = reverse(@sortarch);

$LastArch = $reversearch[0];

@thisarch = split(/\|\#\|/, $LastArch);
$LastNumber = $thisarch[0];
}  else {
	$LastNumber = "000000";
}

$LastNumber++;  #add 1 to last post number
$ArchNum = sprintf("%6d", $LastNumber);
$ArchNum =~tr/ /0/;

mkdir ("$NonCGIPath/Archives/Archive-$ArchNum", 0777);
chmod(0777, "$NonCGIPath/Archives/Archive-$ArchNum");

$ArchiveName = $in{'ArchiveName'};
$ArchiveName =~ s/<.+?>//g;
$ArchiveDesc = $in{'ArchiveDesc'};
$ArchiveDesc =~ s/"/&quot;/g;
$ArchiveDesc =~ s/\n\r\n//g;
$ArchiveDesc =~ s/\n//g;
$ArchiveDesc =~ s/\r//g;
$ArchiveDesc =~ s/  / /g;
$ArchiveDesc =~ s/\|/&#0124;/sg;
$ArchiveName =~ s/\|/&#0124;/sg;
$NewArchive = "$ArchNum|#|$ArchiveName|#|$ArchiveDesc";

#append archives.pl file 
&Lock("lock.file");
open(ARCHIVES, ">>$NonCGIPath/Archives/archives.pl");
print ARCHIVES "$NewArchive\n";
close(ARCHIVES);
&Unlock("lock.file");
chmod(0777, "$NonCGIPath/Archives/archives.pl");

&EndUpdate("A R C H I V &nbsp;&nbsp;&nbsp;&nbsp; E R S T E L L T", "Vielen Dank!  Das von Ihnen gew&uuml;nschte Archiv wurde erfolgreich erstellt.");

}  else {

#process all actions (archives already exist)

#get current archive info--
@archiveinfo = &OpenFile("$NonCGIPath/Archives/archives.pl");
@sortarch = sort(@archiveinfo);
@reversearch = reverse(@sortarch);
$ArchiveTotal = @reversearch;

$LastArch = $reversearch[0];

@thisarch = split(/\|\#\|/, $LastArch);
$LastNumber = $thisarch[0];

if ($LastNumber eq "") {
	$LastNumber = 0;
}
#Figure Next Number, for use in adding archives
$LastNumber++;  #add 1 to last post number
$NextNum = sprintf("%6d", $LastNumber);
$NextNum =~tr/ /0/;

#check names
$ArchiveCount = 0;
foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	if ($Name =~ m/ThisArchiveName/) {
	($Trash, $ThisNumber) = split(/\:/, $Name);
	$Value =~ s/<.+?>//g;
	$Value =~ s/\|/&#0124;/sg;
	$Combine = ("$ThisNumber" . "|#|" . "$Value");
	push (@ArchNames, $Combine);
	$ArchiveCount++;
	}
	if ($Name eq "NewArchiveName") {
		$Value =~ s/<.+?>//g;
		$Value =~ s/\|/&#0124;/sg;
		if (($Value ne "") && ($Value =~ /[a-zA-Z0-9]/)) {
		$NewOne = ("$NextNum" . "|#|" . "$Value");
		$AddNew = "true";
		push (@ArchNames, $NewOne);
		#create directory!
		mkdir ("$NonCGIPath/Archives/Archive-$NextNum", 0777);
chmod(0777, "$NonCGIPath/Archives/Archive-$NextNum");
		}
	}
	if ($Name =~ m/Delete/) {
		push(@deletelist, $Value);
	}
	#check for double pipestems- don't allow
	if ($Value =~ /\|\#\|/) {
		&StandardHTML("FEHLER: Sie d&uuml;rfen in dem Namen oder der Beschreibung des Archivs keine Sonderzeichen wie |#| verwenden - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
	}
} # end foreach $row

if ($ArchiveTotal ne "$ArchiveCount") {
&StandardHTML("Sie versuchen, unvollst&auml;ndige Daten zu versenden - m&ouml;glicherweise haben Sie die ZUR&Uuml;CK-Funktion Ihres Browsers benutzt.  <A HREF=\"$CGIURL/cpanel.cgi?action=archives\">Bitte identifizieren Sie sich erneut.</A>");
exit;
}

if (@deletelist) {
foreach $uno(@deletelist) {
	chomp($uno);
	foreach $one(@ArchNames) {
		chomp($one);
		unless ($one =~ /^$uno/) {
			push(@AdjustNames, $one);
		}
	}
}
} else {
@AdjustNames = @ArchNames;
}

#Now add archive descriptions--
foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	if ($Name =~ m/ThisArchiveDesc/) {
	($Trash, $ThisNumber) = split(/\:/, $Name);
		foreach $check(@AdjustNames) {
		chomp($check);
			if ($check =~ /^$ThisNumber/) {
				$Value =~ s/"/&quot;/g;
				$Value =~ s/\n\r\n//g;
				$Value =~ s/\n//g;
				$Value =~ s/\r//g;
				$Value =~ s/  / /g;
				$Value =~ s/\|/&#0124;/sg;
				$NewLine = ("$check" . "|#|$Value");
				push(@FinalArch, $NewLine);
			}
		}
	}
	if ($AddNew eq "true") {
		if ($Name eq "NewArchiveDesc") {
			foreach $check2(@AdjustNames) {
				chomp($check2);
				if ($check2 =~ /^$NextNum/) {
					$Value =~ s/"/&quot;/g;
					$Value =~ s/\n\r\n//g;
					$Value =~ s/\n//g;
					$Value =~ s/\r//g;
					$Value =~ s/  / /g;
					$Value =~ s/\|/&#0124;/sg;
					$AddLine = ("$check2" . "|#|$Value");
					push (@FinalArch, $AddLine);
				}
			}
		}
	}

} # end foreach $row

@SortFinal = sort(@FinalArch);
#adjust archives.pl file--
&Lock("lock.file");
open(ARCHIVES, ">$NonCGIPath/Archives/archives.pl");
foreach $iota(@SortFinal) {
chomp($iota);
print ARCHIVES "$iota\n";
}
close(ARCHIVES);
&Unlock("lock.file");
chmod(0777, "$NonCGIPath/Archives/archives.pl");

		&EndUpdate("A R C H I V E  &nbsp;&nbsp;&nbsp;&nbsp; A K T U A L I S I E R T", "<center>Vielen Dank!  Die Archive wurden erfolgreich aktualisiert.</center>");
}

} # end if proceed eq true

}  #end Archive Center

sub EnterArchive {
&VerifyAdmin($UserName, $Password);

if ($Proceed eq "true") {

$PageTitle = "A R C H I V E";
&HEADERHTML;


print<<MIDDLE;
<center>
<FORM ACTION="$CGIURL/archive.cgi" NAME="THEFORM" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="archivecenter">
<table border=0 cellpadding=0 cellspacing=0 width="95%"><TR><td bgcolor="#000000">
<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>
MIDDLE

# check to see if archives.pl file exists
if (-e "$NonCGIPath/Archives/archives.pl") {
# open it
@archives = &OpenFile("$NonCGIPath/Archives/archives.pl");
$ArchiveTotal = @archives;

if ($ArchiveTotal <= 40) {
	$AddArchive = qq(<TR bgcolor="#B0BB9D"><td colspan=3><FONT SIZE="2" FACE="Verdana, Arial"><A NAME="#addit">Hier k&ouml;nnen Sie ein neues Archiv erstellen:</A></font></TD></tr>
<TR bgcolor="#C7C6BA">
<TD colspan=2 valign=top><FONT SIZE="1" FACE="Verdana, Arial"><B>Neues Archiv:</B></font></td>
<td>
<TABLE BORDER=0><TR><TD valign=top><FONT SIZE="1" FACE="Verdana, Arial">Name:</font></td><td valign=top><INPUT TYPE="TEXT" NAME="NewArchiveName" VALUE="" SIZE=40 MAXLENGTH=120></td></tr><TR><TD valign=top><FONT SIZE="1" FACE="Verdana, Arial">Beschreibung:</font></td><td><TEXTAREA NAME="NewArchiveDesc" ROWS=3 COLS=30></TEXTAREA></td></tr></table></TD></tr>);
$StatusLine = qq!  Sie haben derzeit $ArchiveTotal Archive(e).  In der Beschreibung des Archivs k&ouml;nnen Sie HTML-Code, jedoch keinen UBB-Code verwenden. Um ein neues Archiv zu erstellen, klicken Sie <A HREF="#addit">hier</A>.!;
}  else {
	$AddArchive = "";
	$StatusLine = qq"Sie haben derzeit $ArchiveTotal Archiv(e).  Es kann kein neues Archiv angelegt werden, da Sie das Maximum von 40 Archiven erreicht haben. In der Beschreibung des Archivs k&ouml;nnen Sie HTML-Code, jedoch keinen UBB-Code verwenden.";
}
print<<HEADER;
<INPUT TYPE="HIDDEN" NAME="ArchiveOption" VALUE="ALL">
<TR bgcolor="#FFFFFF"><TD colspan=3><FONT SIZE="2" FACE="Verdana, Arial">$StatusLine</font></td></tr>
<TR bgcolor="#B0BB9D">
<td colspan=3><CENTER><FONT SIZE="2" FACE="Verdana, Arial"><B>- VORHANDENE ARCHIVE -</B></font></CENTER></td></tr>
<TR bgcolor="#B0BB9D">
<td><FONT SIZE="1" FACE="Verdana, Arial">L&ouml;schen?</font></td>
<TD><FONT SIZE="1" FACE="Verdana, Arial">Archiv - Nummer</FONT></TD>
<TD><FONT SIZE="1" FACE="Verdana, Arial">Name und Beschreibung des Archivs</font></TD></tr>
HEADER

foreach $uno(@archives) {
@thisarch = split(/\|\#\|/, $uno);
chomp($thisarch[2]);

if ($thisarch[0] ne "") {
print<<ROW;
<TR bgcolor="#C7C6BA">
<td valign=top><INPUT TYPE="CHECKBOX" NAME="Delete" VALUE="$thisarch[0]"></td>
<TD valign=top><FONT SIZE="1" FACE="Verdana, Arial">$thisarch[0]</FONT></TD>
<TD valign=top><TABLE BORDER=0><TR><TD valign=top><FONT SIZE="1" FACE="Verdana, Arial">Name:</font></td><td valign=top><INPUT TYPE="TEXT" NAME="ThisArchiveName:$thisarch[0]" VALUE="$thisarch[1]" SIZE=40 MAXLENGTH=120></td></tr><TR><TD valign=top><FONT SIZE="1" FACE="Verdana, Arial">Beschreibung:</font></td><td><TEXTAREA NAME="ThisArchiveDesc:$thisarch[0]" ROWS=3 COLS=30>$thisarch[2]
</TEXTAREA></td></tr></table></TD></tr>
ROW
}
}

#print New Archive Option row--
print<<ROW;
$AddArchive
<TR bgcolor="#B0BB9D"><TD colspan=2><FONT SIZE="2" FACE="Verdana, Arial">Benutzername:</FONT></td><td><INPUT TYPE="TEXT" NAME="UserNameCheck" SIZE=25 MAXLENGTH=50></td></tr>
<TR bgcolor="#B0BB9D"><TD colspan=2><FONT SIZE="2" FACE="Verdana, Arial">Kennwort:</FONT></td><td><INPUT TYPE="PASSWORD" NAME="PasswordCheck" SIZE=13 MAXLENGTH=13></td></tr>

ROW

}  else {
#no archives have been created...
print<<MIDDLE2;
<TR bgcolor="#C7C6BA"><TD colspan=2><FONT SIZE="2" FACE="Verdana, Arial">
Es existieren noch keine Archive. Um ein Archiv zu erstellen, geben Sie bitte den Namen und die Beschreibung des zu erstellenden Archivs ein.  Die Beschreibung erscheint unter dem Namen bei der Anzeige des Archivs.  Dieses Feld k&ouml;nnen Sie leer lassen.  In der Beschreibung des Archivs k&ouml;nnen Sie HTML-Code, jedoch keinen UBB-Code verwenden.</font></td></tr>
<INPUT TYPE="HIDDEN" NAME="ArchiveOption" VALUE="Create">
<TR bgcolor="#C7C6BA"><TD><FONT SIZE="2" FACE="Verdana, Arial">Name des Archivs</FONT></td><td><INPUT TYPE="TEXT" NAME="ArchiveName" SIZE=25 MAXLENGTH=120></td></tr>
<TR bgcolor="#C7C6BA"><TD><FONT SIZE="2" FACE="Verdana, Arial">Beschreibung des Archivs</FONT></td><td><TEXTAREA NAME="ArchiveDesc" ROWS=3 COLS=25></TEXTAREA></td></tr>
<TR bgcolor="#C7C6BA"><TD><FONT SIZE="2" FACE="Verdana, Arial">Benutzername:</FONT></td><td><INPUT TYPE="TEXT" NAME="UserNameCheck" SIZE=25 MAXLENGTH=50></td></tr>
<TR bgcolor="#C7C6BA"><TD><FONT SIZE="2" FACE="Verdana, Arial">Kennwort:</FONT></td><td><INPUT TYPE="PASSWORD" NAME="PasswordCheck" SIZE=13 MAXLENGTH=13></td></tr>
MIDDLE2

}




print<<BOTTOM;
</table>
</td></tr></table>
<P>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="&Auml;nderungen speichern">
</FORM>
</center>
</font></BODY></HTML>
BOTTOM
}  #end if admin
}

sub SubmitTransfer {
if ( ($in{'UserName'} eq "") || ($in{'Password'} eq "") || ($in{'Option'} eq "") )  {
&StandardHTML("Sie m&uuml;ssen Ihren Benutzernamen und Ihr Kennwort eingeben und \"Transferieren\" oder \"Archivieren\" ausw&auml;hlen!");
exit;
}		

$ProfileNumber = &GetUserNumber($UserName);
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

unless ($NameFound eq "yes") {
&StandardHTML("Der von Ihnen eingegebene Benutzername ist dem System nicht bekannt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}

@profilestats = &OpenProfile("$ProfileNumber.cgi");
	
	unless ($in{'Password'} eq "$profilestats[1]") {
	&StandardHTML("Das von Ihnen eingegebene Kennwort ist falsch - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	exit;
	}
	
	$Status = "$profilestats[8]";
	
	#get moderator for this forum
	$Moderator = ("Forum" . "$number" . "Moderator");
	$Moderator = $$Moderator;
	
@mods = split(/\|\|\^\|\|/, $Moderator);

$ModMatch = "";
foreach $unomod(@mods) {
if ($unomod eq "$UserName") {
	$ModMatch = "true";
}
}
unless (($Status eq "Administrator") || ($ModMatch eq "true")) {
	   &StandardHTML("F&uuml;r diese Funktion sind Sie nicht autortisiert - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers.");
	exit;
}

if ($topic !~ /^\d\d\d\d\d\d\.cgi$/) {
&StandardHTML("Ihr Zugriff wurde protokolliert!");
exit;
}

if ($in{'Option'} eq "Transfer") {
#do transfer--

#check to make sure they selected a forum!
$NewNumber = $in{'TransferToForumNum'};

if ($NewNumber eq "") {
&StandardHTML("Sie haben kein Forum ausgew&auml;hlt, wohin Sie dieses Thema verschieben m&ouml;chten - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}

#first get info on old forum
@oldforum = &GetForumRecord($number);
$OldLWA = $oldforum[6];
$OldLWAPassword = &decodeURL($oldforum[7]);
$OldForumStatus = $oldforum[3];
$OldPrivateMax = $oldforum[13];
chomp($OldPrivateMax);
$OrigForum= $Forum;
$OrigForumCoded = $ForumCoded;

#then get info on forum to transfer into
@newforum = &GetForumRecord($NewNumber);
$NewLWA = $newforum[6];
$NewForumStatus = $newforum[3];
$NewLWAPassword = &decodeURL($newforum[7]);
$NewPrivateMax = $newforum[13];
chomp($NewPrivateMax);
$NewForumName = $newforum[1];

#set proper path(s) if forum is private
if ($OldLWA eq "private") {
	$OldPath = "Forum$number/private-$OldLWAPassword";
}  else {
	$OldPath = "Forum$number";
}
if ($NewLWA eq "private") {
	$NewPath = "Forum$NewNumber/private-$NewLWAPassword";
}  else {
	$NewPath = "Forum$NewNumber";
}

#open old topic
open (THETOPIC, "$ForumsPath/$OldPath/$topic"); 
    @thetopic = <THETOPIC>;
close (THETOPIC);


#get new forum stats - last topic number
##determine last topic number and increment by 1
if (-e "$ForumsPath/$NewPath/lastnumber.file") {
open (FORUMCOUNT, "$ForumsPath/$NewPath/lastnumber.file"); 
    @forumcounter = <FORUMCOUNT>;
close (FORUMCOUNT);
$lastthreadnum = $forumcounter[0];
chomp($lastthreadnum);

}  else {
$lastthreadnum = 0;
}

$count = $lastthreadnum + 0;

#determine new topic number
if ($count > 0) {
$lastthreadnum++;
$newtopic = sprintf("%6d", $lastthreadnum);
$newtopic =~tr/ /0/;
}  else {
$newtopic = "000001";
}

#write old file in new directory
open (THETOPIC, ">$ForumsPath/$NewPath/$newtopic.cgi"); 
foreach $uno(@thetopic) {
chomp($uno);
print THETOPIC "$uno\n";
}
close (THETOPIC);
chmod(0777, "$ForumsPath/$NewPath/$newtopic.cgi");

$TotalPosts = @thetopic;
$TotalPosts--;

if ($in{'TransferChoiceOption'} eq "Delete") {
($topicnumber, $junk) = split(/\./, $topic);

#delete old topic and HTML files
unlink ("$ForumsPath/$OldPath/$topic");
unlink ("$ForumsPath/$OldPath/HTML/$topicnumber.html");
unlink ("$ForumsPath/$OldPath/HTML/$topicnumber.cgi");


#update old stats, threads file, etc.
$ExactPath = "$OldPath";
&UpdateForumDetails($number);
&UpdateForumTotals("$number", 1, $TotalPosts, "yes");

}  else {
#keep old message in old forum, but close it!

#close it--
@stats = split(/\|\|/, $thetopic[0]);
$Notes = $stats[1];
chomp($stats[4]);
chomp($stats[5]);
chomp($stats[6]);
chomp($stats[7]);

if ($Notes =~ /N/) {
	$AddN = "N";
}  else {
	$AddN = "";
}

$CloseNote = "Dieses Thema wurde in das Forum $NewForumName verschoben.";
#prepare new stats line
$StatsLine = "A||X$AddN||$stats[2]||$stats[3]||$stats[4]||$stats[5]||$stats[6]||$CloseNote";

foreach $row(@thetopic) {
chomp($row);
if ($row =~ m/^A/) {
	push(@revised, $StatsLine);
}  else {
	push(@revised, $row);
}
}

# update ubb file
&Lock("lock.file");
open (FORUM, ">$ForumsPath/$OldPath/$topic"); 
foreach $ubbline(@revised) {
chomp($ubbline);
print FORUM ("$ubbline\n");
}
close (FORUM);
&Unlock("lock.file");
chmod(0666, "$ForumsPath/$OldPath/$topic");

#redo HTML page
$LWA= $OldLWA;
$PrivateMax = $OldPrivateMax;
&CreateThreadHTML("Forum$number", "$topic", "0", "1");

#update threads summary file
&CurrentDate;
if (-e "$ForumsPath/$OldPath/forum$number.threads") {
&AdjustForClose($number, $topic, "close");
}  else {
&ForumSummary($number);
}

} #end if delete/keep


#update new stats, threads file, etc.
$ExactPath = "$NewPath";
$Forum = $NewForumName;
$ForumCoded = &HTMLIFY($NewForumName);
$ForumCoded =~ tr/ /+/;
$oldnumber = $number;
$number = $NewNumber;
#create NEW HTML Page

$LWA = "$NewLWA";
$PrivateMax = "$NewPrivateMax";

&UpdateForumDetails($NewNumber);
&IncreaseForumTotals("$NewNumber", 1, $TotalPosts, "yes");

if ($NewLWA eq "private") {
&AppendPrivateIndex("$NewNumber", "$newtopic.cgi", "$LWAPassword");
}  else {
if ($IndexMethod eq "ONEFILE") {
&AppendIndex("$NewNumber", "$newtopic.cgi");
} else {
&AppendIndex2("$NewNumber", "$newtopic.cgi");
}
}

#send onscreen confirmation
&Forward("$CGIURL/postings.cgi?action=redoHTML&number=$NewNumber&OldNumber=$oldnumber&topic=$newtopic.cgi", "Dieses Thema wurde erfolgreich verschoben!  Bitte warten Sie ...");

exit;

}  else {
#do archive---
if ($in{'ArchiveSelect'} eq "") {
&StandardHTML("Sie haben kein Archiv ausgew&auml;hlt, wohin Sie dieses Thema verschieben m&ouml;chten - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
exit;
}

#first get info on forum
@oldforum = &GetForumRecord($number);
$OldLWA = $oldforum[6];
$OldLWAPassword = &decodeURL($oldforum[7]);
$OldForumStatus = $oldforum[3];
$OldPrivateMax = $oldforum[13];
chomp($OldPrivateMax);
$OrigForumCoded = $ForumCoded;
if ($OldLWA eq "private") {
	$OldPath = "Forum$number/private-$OldLWAPassword";
}  else {
	$OldPath = "Forum$number";
}

#print topic file to archive--
@topicfile = &OpenFile("$ForumsPath/$OldPath/$topic");
$Top = $topicfile[0];
@checkthis = split(/\|\|/, $Top);
$TotReplies = $checkthis[2];
$ArchiveNumber = $in{'ArchiveSelect'};

if ($checkthis[5] =~ /$ArchiveNumber\:/) {
	&StandardHTML("Dieses Thema wurde bereits archiviert. Ein Thema kann nur einmal in das gleiche Archiv verschoben werden - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers.");
exit;
}

&CurrentDate;
($topicnumber, $junk) = split(/\./, $topic);

$NewArchiveName = "$Today-$number-$topicnumber.cgi";

open(ARCH, ">$NonCGIPath/Archives/Archive-$ArchiveNumber/$NewArchiveName");
foreach $topline(@topicfile) {
chomp($topline);
print ARCH "$topline\n";
}
close(ARCH);

chmod (0666, "$NonCGIPath/Archives/Archive-$ArchiveNumber/$NewArchiveName");

#add to archive threads file--
&AppendArchiveSumm("$ArchiveNumber", "$NewArchiveName");

#create archive HTML file
&CreateArchiveHTML("$ArchiveNumber", "$NewArchiveName", "0", "1");

#add to archive index--
&AppendArchiveIndex("$ArchiveNumber", "$NewArchiveName");

if ($in{'ArchiveChoiceOption'} eq "Keep") {
#mark topic to note that it has already been archived
&MarkForumTopic("$ForumsPath/$OldPath/$topic", "$ArchiveNumber", "$NewArchiveName");
&EndUpdate("T H E M A &nbsp;&nbsp;&nbsp;&nbsp; A R C H I V I E R T", "Das von Ihnen ausgew&auml;hlte Thema wurde erfolgreich archiviert, bleibt jedoch in Originalfassung erhalten.<P>Gehe zu: <A HREF=\"$CGIURL/Ultimate.cgi?action=intro&BypassCookies=true\">&Uuml;bersicht der Foren</A>");
}  else {
#delete old topic and HTML file, and remove from forum index
unlink("$ForumsPath/$OldPath/$topic");
if (-e "$ForumsPath/$OldPath/HTML/$topicnumber.html") {
unlink("$ForumsPath/$OldPath/HTML/$topicnumber.html");
}  else {
unlink("$ForumsPath/$OldPath/HTML/$topicnumber.cgi");
}
$ExactPath = "$OldPath";
&UpdateForumDetails($number);

#update lastnumber.file
$TotReplies = $TotReplies + 0;
$TotThreadPosts = $TotReplies + 1;
&UpdateForumTotals("$number", 1, $TotThreadPosts, "yes");

&EndUpdate("T H E M A &nbsp;&nbsp;&nbsp;&nbsp; A R C H I V I E R T", "Das von Ihnen ausgew&auml;hlte Thema wurde erfolgreich archiviert und in der Originalfassung gel&ouml;scht.<P>Gehe zu: <A HREF=\"$CGIURL/Ultimate.cgi?action=intro&BypassCookies=true\">&Uuml;bersicht der Foren</A>");
}
}
}  #end SubmitTransfer

sub Transfer {
print<<TransferIt;
<HTML><HEAD>
<TITLE>
$BBName - Thema transferieren
</TITLE>
</HEAD>
 <BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
<FONT SIZE="$TextSize" FACE="$FontFace" color="$TextColor">
$Header</font>
<table border=0>
<TR><TD>
<A HREF="Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle"  BORDER=0></A></td>
<td valign=top>
<FONT SIZE="$TextSize" FACE="$FontFace" color="$TextColor">
<B>
Forum: <FONT COLOR="$VisitedLinkColor">$Forum </FONT>
<BR>
Thema: <FONT COLOR="$VisitedLinkColor">$TopicSubject</FONT>
</B>
</FONT>

</td></tr></table>
<P>
<CENTER><FONT SIZE="1" FACE="$FontFace"><B>Hinweis: Nur autorisierte Benutzer ($AdminTitle, $ModeratorTitle) k&ouml;nnen Themen verschieben oder archivieren.</B><br>
</FONT>

<FORM ACTION="$CGIURL/archive.cgi" NAME="REPLIER" METHOD="POST">
$BorderTop
<table border=0 cellspacing=1 cellpadding=4 width="$TableWidth2">
<TR $TableColorStrip><TD colspan=3><CENTER><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$TableStripTextColor"><B>Bitte w&auml;hlen Sie (Transferieren oder Archivieren)</B>
</font></CENTER>
</td></tr>
<tr $AltColumnColor1><td valign=top><INPUT TYPE="RADIO" NAME="Option" VALUE="Transfer"></td><td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$TextColor">Beitrag in dieses Forum verschieben:</FONT>
<BR>
<BR>
<FONT SIZE="1" FACE="$FontFace" COLOR="$TextColor">
<b>Hinweis:</b> Sie haben die Wahl, den Beitrag aus dem Original-Forum zu l&ouml;schen nachdem dieser in das neue Forum verschoben wurde, oder das der Beitrag im Original-Forum verbleibt (er wird dann im Original-Forum geschlossen).</font>
<blockquote>
<INPUT TYPE="RADIO" NAME="TransferChoiceOption" VALUE="Keep" CHECKED><FONT SIZE="1" FACE="$FontFace" COLOR="$TextColor">Der Beitrag soll nach dem Transfer im Original-Forum verbleiben. Der Beitrag wird im Original-Forum geschlossen.<BR>
<INPUT TYPE="RADIO" NAME="TransferChoiceOption" VALUE="Delete">Dieser Beitrag soll nach dem Transfer im Original-Forum gel&ouml;scht werden.</FONT>

</blockquote></td>
<td valign=top>
<SELECT NAME="TransferToForumNum">
<OPTION value="">Forum ausw&auml;hlen ->
TransferIt

&GetForumList;

print<<Transfer2;
</select>
</td>
</tr>
<tr $AltColumnColor2>
<td valign=top><INPUT TYPE="RADIO" NAME="Option" VALUE="Archive"></td><td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$TextColor">Archiviere Beitrag im Archiv:</FONT><BR>
<BR>
<FONT SIZE="1" FACE="$FontFace" COLOR="$TextColor">
<b>Hinweis:</b> Der Beitrag wird in ein Nur-Lesen-Archiv verschoben und kann im Original-Forum gel&ouml;scht/nicht gel&ouml;scht werden (w&auml;hlen Sie, ob der Beitrag im Original-Forum nach der Archivierung gel&ouml;scht werden soll, oder ob er im Original-Forum verbleiben soll.)</font>
<blockquote>
<INPUT TYPE="RADIO" NAME="ArchiveChoiceOption" VALUE="Keep" CHECKED><FONT SIZE="1" FACE="$FontFace" COLOR="$TextColor">Beitrag soll im Original-Forum nach der Archivierung verbleiben.<BR>
<INPUT TYPE="RADIO" NAME="ArchiveChoiceOption" VALUE="Delete">Beitrag im Original-Forum nach der Archivierung l&ouml;schen.</FONT>

</blockquote>
</td>
<td valign=top>
<SELECT NAME="ArchiveSelect">

Transfer2

@archives = &OpenFile("$NonCGIPath/Archives/archives.pl");
if  ($archives[0] ne "") {
print qq(<OPTION VALUE="">Archiv ausw&auml;hlen ->);

foreach $arch(@archives) {
($ArchNum, $ArchName, $ArchDesc) = split(/\|\#\|/, $arch);
	print qq(<OPTION VALUE="$ArchNum">$ArchName);
}
} else {
print qq(<OPTION VALUE="">Es existieren keine Archive!);
}

print<<Transfer3;
</SELECT>
</td>
</tr>
<TR $AltColumnColor1>
<TD colspan=2><B><FONT FACE="$FontFace" SIZE="$TextSize">
Benutzername:</FONT>
</B>
</TD>
<TD>
<INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td>
</tr>
<TR $AltColumnColor2><TD colspan=2><B><FONT FACE="$FontFace" SIZE="$TextSize">
Kennwort:</FONT>
</B>
</TD>
<TD>
<INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td>
</tr>
</table>
$BorderBottom
<p>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="submittransfer">
<INPUT TYPE="HIDDEN" NAME="TopicSubject" VALUE="$TopicSubject">
<INPUT TYPE="HIDDEN" NAME="forum" VALUE="$Forum">
<INPUT TYPE="HIDDEN" NAME="number" VALUE="$number">
<INPUT TYPE="HIDDEN" NAME="topic" VALUE="$topic">
<p>
<INPUT TYPE="Submit" NAME="SUBMIT" VALUE="Auswahl best&auml;tigen">
<INPUT TYPE="RESET" NAME="RESET" VALUE="Felder l&ouml;schen">
</form>
<P>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
var dc = document.cookie;
var testUserName = getCookie("UserName");
var testPassword = getCookie("Password");

if (document.cookie) {

	if (testUserName == null) {  
document.REPLIER.UserName.focus();
	} else {
	document.REPLIER.UserName.value = getCookie("UserName");
document.REPLIER.Password.value = getCookie("Password");
	}
}  else {
document.REPLIER.UserName.focus();
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

</blockquote>
<P>
Transfer3

&PageBottomHTML;
}

sub GetForumList {
@forums = &OpenForumsFile;

for $each(@forums) {
	@ForumLine = split(/\|/, $each);
	chomp($ForumLine[8]);
		if (($ForumLine[3] eq "On") && ($number != $ForumLine[8])) {
print<<SelectHTML;
<OPTION value="$ForumLine[8]">$ForumLine[1]
SelectHTML
		}
}  #end for loop

}


sub IncreaseForumTotals {
## Used to add thread and/or posts totals in lastnumber.file

my $number = shift;
my $AddThreads = shift;
my $AddPosts = shift;
my $UpdateRow1 = shift;

###

open(FORUM, "$ForumsPath/$ExactPath/lastnumber.file");
	@currnumber = <FORUM>;
close(FORUM);

my $threadfilenum = $currnumber[0];
chomp($threadfilenum);
my $totalthreads = $currnumber[1];
chomp($totalthreads);
my $totalposts = $currnumber[2];
chomp($totalposts);

$totalthreads = $totalthreads + $AddThreads;
$totalposts = $totalposts + $AddPosts;

if ($UpdateRow1 eq "yes") {

opendir (FORUMDIR, "$ForumsPath/$ExactPath"); 
    my @theubbfiles = grep(/\.[cgi|ubb]/, readdir(FORUMDIR));
closedir (FORUMDIR);

#sort the ubb files
@ubbfiles = sort(@theubbfiles);
#reverse array so that largest number is first
@ubbfiles = reverse(@ubbfiles);
my $lastnumber = $ubbfiles[0];
($lastnumber, $junk) = split(/\./, $lastnumber);
$threadfilenum = $lastnumber;
}

&Lock("lock.file");
open(FORUM, ">$ForumsPath/$ExactPath/lastnumber.file");
print FORUM ("$threadfilenum\n");
print FORUM ("$totalthreads\n");
print FORUM ("$totalposts\n");
close(FORUM);
&Unlock("lock.file");

chmod(0666, "$ForumsPath/$ExactPath/lastnumber.file");
} #end IncreaseForumTotals

sub HEADERHTML {

if ($in{'UserName'} eq "") {
$UserName = "";
$Password = "";

}
print<<HEADER;
<HTML>
<HEAD>
	<TITLE>$BBName</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE

var testUserNameCP = getCookie("UserNameCP");

var CookieUNCP = escape("$UserName");
var CookiePWCP = escape("$Password");

	if ((testUserNameCP == null) && (CookieUNCP != "")){
	  	document.cookie = "UserNameCP=" + CookieUNCP + ";";
		document.cookie = "PasswordCP=" + CookiePWCP + ";";
	} 
	
function SetCursor() {
var thisUserNameCP = getCookie("UserNameCP");
var thisPasswordCP = getCookie("PasswordCP");

if (thisUserNameCP != null) {  
thisUserNameCP = unescape(thisUserNameCP);
thisPasswordCP = unescape(thisPasswordCP);

	document.THEFORM.UserNameCheck.value = thisUserNameCP;
document.THEFORM.PasswordCheck.value = thisPasswordCP;
	}  
}

function Check(form)  {
if ((form.Password.value == "") || (form.UserName.value == ""))  {
	alert ("Sie m&uuml;ssen Ihren Benutzernamen und Ihr Kennwort eingeben!");
	return false
	}  else  {
	return true
	}
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length; 
            return unescape(dc.substring(begin, end));  }
}
return null;
}
// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</HEAD>
<BODY bgcolor="#FFFFFF" link="#000080" vlink="#808000" onLoad="SetCursor()">
<BR>
<center>
<FONT SIZE="2" FACE="Verdana, Arial">$PageTitle</FONT>
</center>
<P>
<FONT SIZE="2" FACE="Verdana, Arial">
HEADER
} #end HEADERHTML sr


sub CreateArchiveHTML {
my $ArchiveNumber = shift;
my $ArchiveTopic = shift;
my $ArrayStart = shift;
my $PageNumber = shift;

$PageNumber = $PageNumber + 0;
$ArrayStart = $ArrayStart + 0;

($ThisTopicNumber, $junk) = split(/\./, $ArchiveTopic);

($junk, $thisforumnumber, $junk2) = split(/-/, $ThisTopicNumber);
@thisforum = &GetForumRecord($thisforumnumber);
$ThisForumName = $thisforum[1];

#create random numbers for headers/footers
if ($RandomNumber) {
$RandomNumber = $RandomNumber + 2;
$RandomNumber2 = $RandomNumber2 + 2;
}  else {
@digit = (0..9);
srand(time);
$num1 = rand(10);
$num2 = rand(10); 
$num3 = rand(10);
$num4 = rand(10); 
$RandomNumber = ("$digit[$num1]" . "$digit[$num2]" . "$digit[$num3]" . "$digit[$num4]");

$RandomNumber2 = $RandomNumber + 1004;
}

if ($Header ne "") {
$Header2 = $Header;
$Header2 =~ s/UBBrandomX/$RandomNumber/isg;
$Header2 =~ s/UBBrandomY/$RandomNumber2/isg;
}
if ($Footer ne "") {
$Footer2 = $Footer;
$Footer2 =~ s/UBBrandomX/$RandomNumber/isg;
$Footer2 =~ s/UBBrandomY/$RandomNumber2/isg;
}

@archivelist = &OpenFile("$NonCGIPath/Archives/archives.pl");
foreach $archie(@archivelist) {
	if ($archie =~ /^$ArchiveNumber/) {
		@thisarchie = split(/\|\#\|/, $archie);
		$ArchiveName = $thisarchie[1];
	}
}

@threadinformation = &OpenFile("$NonCGIPath/Archives/Archive-$ArchiveNumber/$ArchiveTopic");

@statarray = split(/\|\|/, $threadinformation[0]);

if ($ReverseThreads eq "TRUE") {
	@threadinfo = reverse(@threadinformation);
	$ALine = pop(@threadinfo);
	chomp($ALine);
	unshift(@threadinfo, $ALine);

}  else {
	@threadinfo = @threadinformation;
}

#adjust for max post per page, if necessary
if (($HTMLDisplayMax ne "") && ($HTMLDisplayMax ne "NONE")) {
my $PostTotal = @threadinfo - 1;
if ($PostTotal > $HTMLDisplayMax) {

$TotalPages = $PostTotal / $HTMLDisplayMax;

if ($TotalPages =~ /\./) {
	($Whole, $junk) = split(/\./, $TotalPages);
	$TotalPages = $Whole + 1;
}  else {
	$TotalPages = $TotalPages;
}

$TopicPageTotal = "Dieses Thema ist $TotalPages Seiten lang:";
$eachpage = "";
for ($eachpage == 1; $eachpage <= $TotalPages; $eachpage++) {
if ($eachpage == 1) {
	$PageName = "$ThisTopicNumber";
}  else {
	$PageName = "$ThisTopicNumber-$eachpage";
}
if ($PageNumber == $eachpage) {
$TopicPageTotal .= qq(&nbsp;$eachpage&nbsp;);
}  else {
$TopicPageTotal .= qq(&nbsp;<A HREF="$NonCGIURL/Archives/Archive-$ArchiveNumber/HTML/$PageName.html">$eachpage</A>&nbsp;)
}
}

$ThisPage = "(Seite $PageNumber)";

	if (($ArrayStart eq "") || ($ArrayStart eq "0")) {
	$MaxPoint = $HTMLDisplayMax;
	@postinfo = @threadinfo[1... $MaxPoint];
	$ContinueAt = $MaxPoint + 1;
	$NextPage = $PageNumber + 1;
	}  else {
	$MaxPoint = ($ArrayStart + $HTMLDisplayMax) - 1;
		if ($MaxPoint >= $#threadinfo) {
			$MaxPoint = $#threadinfo;
			@postinfo = @threadinfo[$ArrayStart... $MaxPoint];
			$ContinueAt = "";
		}  else {
			@postinfo = @threadinfo[$ArrayStart... $MaxPoint];
			$ContinueAt = $MaxPoint + 1;
			$NextPage = $PageNumber + 1;
		}
  }
}  else {
	@postinfo = @threadinfo[1... $#threadinfo];
	$ContinueAt = "";
	$TotalPages = 1;
}

} else {
	@postinfo = @threadinfo[1... $#threadinfo];
	$ContinueAt = "";
	$TotalPages = 1;
}  #end if HTML max display

$TopicWriter = "$statarray[3]";
$UNCoded = $TopicWriter;
$UNCoded =~ tr/ /+/;
$TopicSubject = $statarray[4];
chomp($TopicSubject);
	$SubjectCoded = &HTMLIFY($TopicSubject);
			$SubjectCoded =~ tr/ /+/;

#if Email is ON, display email thread wording
if (($UseEmail eq "ON") && ($ThisRestrict ne "private")) {
	$EmailThreadWording = qq(<P><IMG SRC="$NonCGIURL/ubbfriendminiicon.gif" BORDER=0> <A HREF="$CGIURL/ubbmisc.cgi?action=sendthread&thread=$NonCGIURL/Archives/Archive-$ArchiveNumber/HTML/$ThisTopicNumber.html&Subject=$SubjectCoded">UBBFriend: Senden Sie dieses Thema an einen Freund!</A>);
}  else {
	$EmailThreadWording = "";
}

unless (-d "$NonCGIPath/Archives/Archive-$ArchiveNumber/HTML") {
mkdir("$NonCGIPath/Archives/Archive-$ArchiveNumber/HTML", 0777);
chmod (0777, "$NonCGIPath/Archives/Archive-$ArchiveNumber/HTML");
}

$FolderLine = qq(<IMG SRC="$NonCGIURL/open.gif"  BORDER=0>&nbsp;&nbsp;<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true">$BBName</A>
<br><IMG SRC="$NonCGIURL/tline.gif" BORDER=0><IMG SRC="$NonCGIURL/open.gif"  BORDER=0>&nbsp;&nbsp;<A HREF="$CGIURL/forumdisplay.cgi?action=topics&number=A:$ArchiveNumber">$ArchiveName</A>
<br>
<IMG SRC="$NonCGIURL/tline3.gif" BORDER=0><IMG SRC="$NonCGIURL/open.gif" BORDER=0>&nbsp;&nbsp;$TopicSubject $ThisPage);


if ($DisplayRegistration eq "NO") {
$RegLinkHere = "";
}  else {
$RegLinkHere = qq(<A HREF="$CGIURL/ubbmisc.cgi?action=editbio&Browser=$Browser&DaysPrune=$DaysPrune&LastLogin=$in{'LastLogin'}"><ACRONYM TITLE="Editieren Sie Ihr Profil">Profil</ACRONYM></A> | <A HREF="$CGIURL/Ultimate.cgi?action=agree"><ACRONYM TITLE="Registration ist kostenlos!">Registrieren</ACRONYM></A> |);
}

$ThisThread = qq(<HTML><HEAD><TITLE>Archive: $TopicSubject - $BBName</title><META HTTP-EQUIV="Pragma" CONTENT="no-cache"></head> <BODY $BGColor  $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
<FONT SIZE="$TextSize" FACE="$FontFace">
$Header2<table border=0 width=$TableWidth><TR>
<td valign=top align=left><A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A>
<BR><center><FONT SIZE="1" FACE="$FontFace" COLOR="$LinkColor">Hinweis: Dies ist ein archiviertes Thema - es sind keine Antworten m&ouml;glich.</FONT></center>
</FONT>
</td>
<td valign=top NOWRAP>
<FONT SIZE="1" FACE="$FontFace">
$FolderLine
<center>
$EmailThreadWording
<P><FONT SIZE="1" FACE="$FontFace">
$RegLinkHere <A HREF="$CGIURL/ubbmisc.cgi?action=setprefs"><ACRONYM TITLE="Ver&auml;ndern Sie Ihre Voreinstellungen!">Voreinstellungen</ACRONYM></A> | <A HREF="$NonCGIURL/faq.html" target=_blank><ACRONYM TITLE="Frequently Asked Questions">faq</ACRONYM></A> | <A HREF="$CGIURL/search.cgi?action=intro&default=A:$ArchiveNumber"><ACRONYM TITLE="Suchen nach Begriff, Datum oder Benutzernamen!">Suchen</ACRONYM></A>
<P>
</font>
</center>
</td></tr></table><center>
<BR>
<TABLE BORDER=0 WIDTH=$TableWidth>
<TR><TD valign=bottom><FONT SIZE="1" face="$FontFace">$TopicPageTotal<BR>Dieses Thema wurde im Original im Forum <A HREF="$CGIURL/forumdisplay.cgi?action=topics&number=$thisforumnumber">$ThisForumName</A> erstellt.</font></TD></TABLE>
$BorderTop
<table width=$TableWidth2 border=0 cellspacing=1 cellpadding=4>
<TR $TableColorStrip>
<TD valign=middle width=18%>
<FONT SIZE="1" face="$FontFace" color="$TableStripTextColor"><B>Autor</B></FONT>
</TD>
<TD valign=middle>
<FONT SIZE="1" face="$FontFace" color="$TableStripTextColor"><B>Thema:&nbsp;&nbsp; $TopicSubject</B></FONT>
</TD>
</TR>);
@themonths = ("", "JAN", "FEB", "MRZ", "APR", "MAI", "JUN", "JUL", "AUG", "SEP", "OKT", "NOV", "DEZ");
$AlternateColor = "$AltColumnColor2";
##
foreach $line(@postinfo) {
	@thisline = split(/\|\|/, $line);
		$UserNameCoded = $thisline[2];
		$UserNameCoded = &HTMLIFY($UserNameCoded);
		$UserNameCoded =~ tr/ /+/;
		$theDate = "$thisline[3]";
		
		$RegName = "$thisline[8]";
		chomp($RegName);

		#format date
if ($DateFormat eq "US") {
	$ThisDate = "$theDate";
}
elsif ($DateFormat eq "Euro") {
	$ThisDate = &DateFormat("$theDate", "Euro");
}
elsif ($DateFormat eq "USX") {
	$ThisDate = &DateFormat("$theDate", "USExpanded");
} else {
	$ThisDate = &DateFormat("$theDate", "EuroExpanded");
}	
		#format time
		if ($TimeFormat eq "24HR")  {
			@timearray = split(/ /, $thisline[4]);
			chomp($timearray[1]);
			($gethour, $getmin) = split(/:/, $timearray[0]);
		if ($timearray[1] eq "PM") {		
			if ($gethour < 12) {
				$gethour = ($gethour  + 12);
			}
		}
		if ($AMpm eq "AM") {		
			if ($gethour == 12) {
				$gethour = "0";
			}
		}
		$gethour = sprintf ("%2d", $gethour);
		$gethour =~tr/ /0/;
		$getmin = sprintf ("%2d", $getmin);
		$getmin =~tr/ /0/;
		$FormatTime = "$gethour:$getmin";
		} else {
		$FormatTime = "$thisline[4]";
		}
		$theTime = "thisline[4]";
	
		$ReplyText = $thisline[6];
#get reply writer's email view status
my $ProfileNumber = &GetUserNumber($thisline[2]);

if ($ProfileNumber ne "") {

@thisprofile = &OpenProfile("$ProfileNumber.cgi");
$EmailView = $thisprofile[11];
$ThisStatus = $thisprofile[8];

if ($ThisStatus eq "Administrator") {
	$ThisStatus = "$AdminTitle";
}
elsif ($ThisStatus eq "Moderator") {
	$ThisStatus = "$ModeratorTitle";
}
elsif ($ThisStatus eq "Member") {
	$ThisStatus = "$MemberTitle";
}  else {
	$ThisStatus = "$JrMemberTitle";
}
}  else {
	$RegName = "unreg";
}


if ($AuthorColumn eq "Location") {
$RegDate = $thisprofile[10];
($RegMon, $RegDay, $RegYear) = split(/-/, $RegDate);
$RegMonth = $themonths[$RegMon];
$RegDate = "$RegMonth $RegYear";
$AuthorExtra = qq(<P>Beitr&auml;ge: $thisprofile[7]<BR>von: $thisprofile[6]<BR>Registriert: $RegDate);
}
elsif ($AuthorColumn eq "PostTotal") {
$RegDate = $thisprofile[10];
($RegMon, $RegDay, $RegYear) = split(/-/, $RegDate);
$RegMonth = $themonths[$RegMon];
$RegDate = "$RegMonth $RegYear";
$AuthorExtra = qq(<P>Beitr&auml;ge: $thisprofile[7]<BR>Registriert: $RegDate);
}  else {
$AuthorExtra = "";
}

if ($RegName ne "unreg"){
$ProfileString = qq(<A HREF="$CGIURL/ubbmisc.cgi?action=getbio&UserName=$UserNameCoded" target=_blank>
<IMG SRC="$NonCGIURL/$profilegif" BORDER=0 ALT="Klicken Sie hier, um sich das Profil von $thisline[2] anzusehen!"></A>);


if (($EmailBlock eq "ON") || ($EmailView eq "no")) {
$EmailString = "&nbsp;";
}  else {

$EmailString = qq(&nbsp;&nbsp;<A HREF="$CGIURL/Ultimate.cgi?action=email&ToWhom=$UserNameCoded" target=_blank><IMG SRC="$NonCGIURL/$mailgif" BORDER=0 ALT="Senden Sie $thisline[2] eine eMail!"></A>&nbsp;&nbsp;);
} 	
}  else {
$EmailString = "&nbsp;";
$ThisStatus = "unregistriert";
$ProfileString = "&nbsp;";
}

if ($DisplayRegistration eq "NO") {
$EmailString = "&nbsp;";
$ThisStatus = "";
$ProfileString = "&nbsp;";
$EditLink = "";
}

$ThisThread .= qq(<tr $AlternateColor>
	<TD width=18% valign=top>
	<FONT SIZE="$TextSize" face="$FontFace"><B>$thisline[2]</B></font><BR><FONT SIZE="1" face="$FontFace">$ThisStatus $AuthorExtra</FONT>
</td>
<TD>
<IMG SRC="$NonCGIURL/posticon.gif" BORDER=0>
<FONT SIZE="$TextSize" FACE="$FontFace">
<FONT SIZE="1" color="$TimeColor" face="$FontFace">erstellt am $ThisDate um $FormatTime Uhr&nbsp;&nbsp;&nbsp;
$ProfileString $EmailString &nbsp;&nbsp;
</FONT><HR>$ReplyText</FONT><BR><BR></td></tr>);

#rotate thru alt colors
if ($AlternateColor eq "$AltColumnColor1") {
	$AlternateColor = "$AltColumnColor2";
	}  else {
	$AlternateColor = "$AltColumnColor1";
	}
}  # end loop


$ThisThread .= qq(</table>$BorderBottom<table border=0 width="$TableWidth"><TR><TD valign=top align=left><FONT SIZE="1" FACE="$FontFace">$TopicPageTotal<P>Alle Zeitangaben werden im $TimeZone - Format dargestellt.</FONT></td><td valign=top align=right><FONT SIZE="1" FACE="$FontFace">Dies ist ein archiviertes Thema - es sind keine Antworten m&ouml;glich!</font></td></tr>
<tr><td colspan=2></td></tr>
<TR><TD></TD>
<td align=right valign=top NOWRAP>
<FONT SIZE="$TextSize" FACE="$FontFace">
<FORM ACTION="$CGIURL/forumdisplay.cgi" METHOD="GET">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="topics">
<B>Gehe zu: </B><SELECT NAME="number">);

#add forum select list
&GetForumSelectList2;

$ThisThread .= qq(</SELECT>
<INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Los!">
</FORM></FONT></TD></tr></TABLE>
<br><B><FONT SIZE="$TextSize" FACE="$FontFace">
<A HREF="$ContactLink">Kontakt</A> | <A HREF="$HomePageURL" target=_top>$MyHomePage</A> $PrivacyStatement
</B></FONT>
<p><FONT COLOR="$CopyrightTextColor" size="1" FACE="$FontFace">$YourCopyrightNotice
<P>
$infopopcopy<br>
Ultimate Bulletin Board $Version<br><br>
</FONT></CENTER>$Footer2</font></body></html>);

if ($PageNumber eq "1") {
	$HTMLPageName = "$ThisTopicNumber";
}  else {
	$HTMLPageName = "$ThisTopicNumber-$PageNumber";
}

unless (-w "$NonCGIPath/Archives/Archive-$ArchiveNumber/HTML/$HTMLPageName.html") {
unlink "$NonCGIPath/Archives/Archive-$ArchiveNumber/HTML/$HTMLPageName.html";
}

&Lock("lock.file");
open (THREADHTML, ">$NonCGIPath/Archives/Archive-$ArchiveNumber/HTML/$HTMLPageName.html");
print THREADHTML ("$ThisThread");
close (THREADHTML);
&Unlock("lock.file");

chmod (0777, "$NonCGIPath/Archives/Archive-$ArchiveNumber/HTML/$HTMLPageName.html");

if ($ContinueAt ne "") {
	&CreateArchiveHTML("$ArchiveNumber", "$ArchiveTopic", "$ContinueAt", "$NextPage");
}
}  #end CreateArchiveHTML

sub AppendArchiveSumm {
my $ArchiveNumber = shift;
my $ArchiveTopic = shift;

($ThisNum, $junk) = split(/\./, $ArchiveTopic);

@topicfile = &OpenFile("$NonCGIPath/Archives/Archive-$ArchiveNumber/$ArchiveTopic");

@stats = split(/\|\|/, $topicfile[0]);
$stats[3] =~ s/\|/&#0124;/sg;
$ThisSubject = $stats[4];
chomp($ThisSubject);
$ThisSubject =~ s/\|/&#0124;/sg;

$ThreadLine = "$ThisSubject|#|$ThisNum|#|$stats[3]";

&AppendFile("$NonCGIPath/Archives/Archive-$ArchiveNumber/archives.thread", "$ThreadLine");
chmod(0777, "$NonCGIPath/Archives/Archive-$ArchiveNumber/archives.thread");
}


sub AppendArchiveIndex {
my $ArchiveNumber = shift;
my $ArchiveTopic = shift;

($ThisNum, $junk) = split(/\./, $ArchiveTopic);

@topicfile = &OpenFile("$NonCGIPath/Archives/Archive-$ArchiveNumber/$ArchiveTopic");

$TopLine = $topicfile[0];
@stats = split(/\|\|/, $TopLine);
$TopicSubject = $stats[4];
chomp($TopicSubject);
$TopicSubject =~ s/\|/&#0124;/sg;

foreach $uno(@topicfile) {
if ($uno !~ /^A/) {
@thisline = split(/\|\|/, $uno);
$Mess = $thisline[6];
$Message = &Indexify($Mess);
$PostDate = $thisline[3];
$Author = $thisline[2];
$Author =~ s/\|/&#0124;/sg;

$IndexLine = "$ArchiveNumber|$ThisNum|$thisline[2]|$PostDate|$TopicSubject|$Message";
&AppendFile("$NonCGIPath/Archives/archiveindex-$ArchiveNumber.pl", "$IndexLine");
}
}
chmod(0777, "$NonCGIPath/Archives/archiveindex-$ArchiveNumber.pl");
}

sub MarkForumTopic {
my $Path = shift;
my $ArchDir = shift;
my $ArchTopic = shift;

@thistopic = &OpenFile("$Path");
$TopLine = $thistopic[0];

@statline = split(/\|\|/, $TopLine);
chomp($statline[4]);
$ArchiveNotes = $statline[5];
chomp($ArchiveNotes);
chomp($statline[6]);
$ThisNote = "$ArchDir:$ArchTopic,";
if ($ArchiveNotes eq "") {
	$ArchiveNotes = $ThisNote;
}  else {
$ArchiveNotes = ("$ArchiveNotes" . "$ThisNote");
}

$statline[5] = $ArchiveNotes;
$thistopic[0] = join("||", @statline);

&Lock("lock.file");
open (REVISED, ">$Path");
foreach $uno(@thistopic) {
chomp($uno);
print REVISED ("$uno\n");
}
close(REVISED);
&Unlock("lock.file");
}

sub ReArchiveIndex {
my $ArchRow = shift;
my $ArchTotal = shift;
my $StartWith = shift;

$ArchRow = $ArchRow + 0;
$ArchTotal = $ArchTotal + 0;
$StartWith = $StartWith + 0;

#is this the last archive?
if ($ArchRow == $ArchTotal) {
	$LastArchive = "true";
}  else {
	$LastArchive = "false";
}

my @archives = &OpenFile("$NonCGIPath/Archives/archives.pl");
my $uno = "";
my $Count = 0;

foreach $uno(@archives) {
$Count++;
	if ($Count == $ArchRow) {
		($ThisNumber, $junk, $junk2) = split(/\|\#\|/, $uno);
	}
}

#retrieve all topics 
opendir (GETTHREADS, "$NonCGIPath/Archives/Archive-$ThisNumber");
	@threads1 = readdir (GETTHREADS);
closedir (GETTHREADS);

@threads2 = grep(/\.cgi/, @threads1);
@threads = sort(@threads2);

$TotalThreads = @threads; #total topics in archive
$LastArrayNum = $TotalThreads - 1;

#limit processing to Cycle rate of 250 topics
$Cycle = 250;
$ThisCycle = $Cycle - 1;
$ArrayStart = $StartWith - 1;
$End = $StartWith + $ThisCycle;
$ArrayEnd = $End - 1;

if ($LastArrayNum <= $ArrayEnd) {
	$ArrayEnd = $LastArrayNum;
	$FinishedArchive = "true";
}  else {
	$FinishedArchive = "false";
}

@truncated = @threads[$ArrayStart... $ArrayEnd];
$StartPoint = $StartWith;
$LastOne = $ArrayEnd + 1;
$NextStart = $ArrayEnd + 1;
	@forumindex = @blank;
for $this(@truncated) {
	@stat = &OpenFile("$NonCGIPath/Archives/Archive-$ThisNumber/$this");
		@stats = split(/\|\|/, $stat[0]);
		$Subject = $stats[4];
		$Subject =~ s/\|/&#0124;/sg;
		chomp($Subject);
		
		($HTMLpage, $trash) = split(/\./, $this);
	
		foreach $review(@stat) {
			unless ($review =~ /^A/) {
			@parseit = split(/\|\|/, $review);
			my $Writer = $parseit[2];
			my $Date = $parseit[3];
			chomp($parseit[6]);
			my $Text = &Indexify($parseit[6]);
			$Writer =~ s/\|/&#0124;/sg;
			my $threadline .= ("$ThisNumber" . "|" . "$HTMLpage" . "|" . "$Writer" . "|" . "$Date" . "|" . "$Subject" . "|" . "$Text\n");
			push (@forumindex, $threadline);
			} #end unless
		}
} #end for threads loop


if ($ArrayStart == 0) {
unlink("$NonCGIPath/Archives/archiveindex-$ThisNumber.pl");
}

&Lock ("lock.file");
open (THISFILE, ">>$NonCGIPath/Archives/archiveindex-$ThisNumber.pl");
for $line(@forumindex) {
chomp($line);
print THISFILE ("$line\n");
}
close (THISFILE);
&Unlock ("lock.file");
chmod (0666, "$NonCGIPath/Archives/archiveindex-$ThisNumber.pl");

if ($FinishedArchive eq "true") {
	if ($LastArchive eq "true") {
		&EndUpdate("I N D E X &nbsp;&nbsp;&nbsp;&nbsp; A K T U A L I S I E R T", "Vielen Dank f&uuml;r Ihre Geduld. Alle Foren und Archive wurden erfolgreich indiziert.");
	} else {
		$ArchRow++;
		&ContinueArchIndex("$ArchRow", "$ArchTotal", "1");
	}
} else {
		&ContinueArchIndex("$ArchRow", "$ArchTotal" , "$NextStart");
}

} #end rearchiveindex


sub ContinueArchIndex {
my $ArchRow = shift;
my $TotalArchie = shift;
my $NextStart = shift;

$ActionWording = qq(Es werden die vorhandenen Archive neu indiziert.<P>Archiv <FONT FACE="Verdana" SIZE="2" COLOR="Navy">$ThisNumber</FONT> wird derzeit bearbeitet. Bitte warten Sie!</B><P>Die Themen <FONT FACE="Verdana" SIZE="2" COLOR="Navy">$StartPoint</font> bis<FONT FACE="Verdana" SIZE="2" COLOR="Navy"> $LastOne </font> im Archiv <FONT FACE="Verdana" SIZE="2" COLOR="Navy">$ThisNumber</font> wurden erfolgreich berarbeitet.</FONT>);
$ForwardURL = "$CGIURL/archive.cgi?action=ContinueArchiveIndex&ArchiveRow=$ArchRow&TotalArchives=$TotalArchie&StartWith=$NextStart";
&ContinueThis($ForwardURL, $ActionWording);

}


sub UpdateArchThreads {
my $ArchRow = shift;
my $ArchTotal = shift;
my $StartWith = shift;

$ArchRow = $ArchRow + 0;
$ArchTotal = $ArchTotal + 0;
$StartWith = $StartWith + 0;

#is this the last archive?
if ($ArchRow == $ArchTotal) {
	$LastArchive = "true";
}  else {
	$LastArchive = "false";
}

my @archives = &OpenFile("$NonCGIPath/Archives/archives.pl");
my $uno = "";
my $Count = 0;

foreach $uno(@archives) {
$Count++;
	if ($Count == $ArchRow) {
		($ThisNumber, $junk, $junk2) = split(/\|\#\|/, $uno);
	}
}

#retrieve all topics 
opendir (GETTHREADS, "$NonCGIPath/Archives/Archive-$ThisNumber");
	@threads1 = readdir (GETTHREADS);
closedir (GETTHREADS);

@threads2 = grep(/\.cgi/, @threads1);
@threads = sort(@threads2);

$TotalThreads = @threads; #total topics in archive
$LastArrayNum = $TotalThreads - 1;

#limit processing to Cycle rate of 250 topics
$Cycle = 250;
$ThisCycle = $Cycle - 1;
$ArrayStart = $StartWith - 1;
$End = $StartWith + $ThisCycle;
$ArrayEnd = $End - 1;

if ($LastArrayNum <= $ArrayEnd) {
	$ArrayEnd = $LastArrayNum;
	$FinishedArchive = "true";
}  else {
	$FinishedArchive = "false";
}

@truncated = @threads[$ArrayStart... $ArrayEnd];
$StartPoint = $StartWith;
$LastOne = $ArrayEnd + 1;
$NextStart = $ArrayEnd + 1;

for $this(@truncated) {
	@topicfile = &OpenFile("$NonCGIPath/Archives/Archive-$ThisNumber/$this");

($TopicNumber, $junk) = split(/\./, $this);
@stats = split(/\|\|/, $topicfile[0]);
$TopicSubject = $stats[4];
chomp($TopicSubject);
$Author = $stats[3];
$Author =~ s/\|/&#0124;/sg;
$TopicSubject =~ s/\|/&#0124;/sg;

$ThreadLine = "$TopicSubject|#|$TopicNumber|#|$Author";
	push(@threadfile, $ThreadLine);
} #end for threads loop


if ($ArrayStart == 0) {
unlink("$NonCGIPath/Archives/Archive-$ThisNumber/archives.thread");
}

&Lock ("lock.file");
open (THISFILE, ">>$NonCGIPath/Archives/Archive-$ThisNumber/archives.thread");
for $line2(@threadfile) {
chomp($line2);
print THISFILE ("$line2\n");
}
close (THISFILE);
&Unlock ("lock.file");
chmod (0666, "$NonCGIPath/Archives/Archive-$ThisNumber/archives.thread");

if ($FinishedArchive eq "true") {
	if ($LastArchive eq "true") {
		&EndUpdate("U P D A T E &nbsp;&nbsp;&nbsp;&nbsp; E R F O L G R E I C H", "Vielen Dank f&uuml;r Ihre Geduld!  Alle Foren und Archive wurden erfolgreich aktualisiert.");
	} else {
		$ArchRow++;
		&ContinueUpdateThreads("$ArchRow", "$ArchTotal", "1");
	}
} else {
		&ContinueUpdateThreads("$ArchRow", "$ArchTotal" , "$NextStart");
}

} #end updateArchThreads

sub ContinueUpdateThreads {
my $ArchRow = shift;
my $TotalArchie = shift;
my $NextStart = shift;

$ActionWording = qq(Bitte warten Sie!</B><P>Die Themen <FONT FACE="Verdana" SIZE="2" COLOR="Navy">$StartPoint</font> bis<FONT FACE="Verdana" SIZE="2" COLOR="Navy"> $LastOne </font> im Archiv <FONT FACE="Verdana" SIZE="2" COLOR="Navy">$ThisNumber</font> wurden erolgreich aktualisiert.
</FONT>);
$ForwardURL = "$CGIURL/archive.cgi?action=UpdateArchiveThreads&ArchiveRow=$ArchRow&TotalArchives=$TotalArchie&StartWith=$NextStart";
&ContinueThis($ForwardURL, $ActionWording);
}

exit(0); # comply with SafePerl
